!! "@(#) $Id: AlignCalFibres.prg,v 1.3 2003/10/29 05:42:41 jpritcha Exp $"
!! ==============================================================================
!! Script used at the telescope to align calibration fibres with fibre head
!! fibre apertures.
!!
!! Author: J.D.Pritchard
!!
!! ==============================================================================

DEFINE/PARAMETER P1 ThAr CHAR "Image on w2p2tcs"

! In ferosTCCDRtd use Save As to save image with filename {P1}
$ /usr/bin/rcp cam@w2p2tcs:{P1}.fits {P1}.fits

define/local cen1/i/1/2 125,259
define/local cen2/i/1/2 489,259

define/local sf1/i/1/8 0,0,0,0,0,0,0,0
define/local sf2/i/1/8 0,0,0,0,0,0,0,0

sf1(1) = cen1(1) - 12
sf1(2) = cen1(1) + 12
sf1(3) = cen1(2) - 2
sf1(4) = cen1(2) + 2
sf1(5) = cen1(1) - 2
sf1(6) = cen1(1) + 2
sf1(7) = cen1(2) - 12
sf1(8) = cen1(2) + 12
sf2(1) = cen2(1) - 12
sf2(2) = cen2(1) + 12
sf2(3) = cen2(2) - 2
sf2(4) = cen2(2) + 2
sf2(5) = cen2(1) - 2
sf2(6) = cen2(1) + 2
sf2(7) = cen2(2) - 12
sf2(8) = cen2(2) + 12

aver/row {P1}_ObjFibRow = {P1}.fits[{sf1(1)},{sf1(3)}:{sf1(2)},{sf1(4)}] ? SUM
aver/col {P1}_ObjFibCol = {P1}.fits[{sf1(5)},{sf1(7)}:{sf1(6)},{sf1(8)}] ? SUM
aver/row {P1}_SkyFibRow = {P1}.fits[{sf2(1)},{sf2(3)}:{sf2(2)},{sf2(4)}] ? SUM
aver/col {P1}_SkyFibCol = {P1}.fits[{sf2(5)},{sf2(7)}:{sf2(6)},{sf2(8)}] ? SUM


! Need to do this because cent/gaus "Invert=yes" isn't working.
comp/imag {P1}_ObjFibRow = -1.0 * {P1}_ObjFibRow
comp/imag {P1}_ObjFibCol = -1.0 * {P1}_ObjFibCol
comp/imag {P1}_SkyFibRow = -1.0 * {P1}_SkyFibRow
comp/imag {P1}_SkyFibCol = -1.0 * {P1}_SkyFibCol

assi/grap G,0
plot/row {P1}_ObjFibRow
cent/gaus {P1}_ObjFibRow
copy/grap postscript
$ mv postscript.ps {P1}_ObjFibRow.ps
assi/grap G,1
plot/row {P1}_ObjFibCol
copy/grap postscript
$ mv postscript.ps {P1}_ObjFibCol.ps
assi/grap G,2
plot/row {P1}_SkyFibRow
copy/grap postscript
$ mv postscript.ps {P1}_SkyFibRow.ps
assi/grap G,3
plot/row {P1}_SkyFibCol
copy/grap postscript
$ mv postscript.ps {P1}_SkyFibCol.ps
