! @(#)autoreduce.prg	17.1.1.1 (ESO-IPG) 01/25/02 17:52:07
! @(#)autoreduce.prg	14.1.1.1 (ESO-IPG) 09/16/99 09:47:18
! @@ autoreduce.prg	  
! "@(#) $Id: autoreduce.prg,v 1.35 2005/12/15 15:39:31 jpritcha Exp $"
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  autoreduce.prg	  
! O.Stahl, A.Kaufer	981105
!
! PURPOSE
! reduce incoming new frame depending on exposure type
!
! 	exposuretype=FLATFIELD 	:	pre-reduction 
!					adding to catalog FF.cat
!					
! 	exposuretype=CALIBRATION:	pre-reduction 
!					adding to catalog ThAr.cat
!					
! 	exposuretype=SCIENCE 	:	if SHSTAT = CLOSED (-> DARK)
!                                          adding to catalog Dark.cat
!                                       if SHSTAT = CLOSED (-> SCIENCE)
!                                          adding to catalog Object.cat
!                                          pre-reduction 
!					   adding to catalog
!					   background subtraction
!					   order straightening
!					   order extraction		
!					   flatfielding/blaze correction
!					   rebinning: wavelength calibration
!						      barycentric correction
!					   order merging
!					
! USAGE
!
! @@ autoreduce fileprefix filenumber
!
! with : fileprefix	:  fixed filename prefix set by BIAS
!        filenumber 	:  running 4-digit filenumber
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?  C "Enter fileprefix : "
define/par p2 ?  N "Enter filenumber : "
define/par p3 1  C "Object Fibre (1/2) : "
!
define/local etime/d/1/1 0
define/local FIBSEL/C/1/1 {p3}
define/local host/c/1/100   " "
define/local i/i/1/1 {p2}
define/local ISSCIENCE/i/1/1 0
define/local ISSTD/i/1/1 0
define/local infile/c/1/60 {p1}{p2}.mt
define/local lend/r/1/1 0.0
define/local lstart/r/1/1 0.0
define/local num/i/1/1 {p2}
define/local order/i/1/1 {p2}
define/local ra/d/1/1 0.0
define/local rebstep/r/1/2 0.0
define/local symMkHTML/c/1/1 " "
!
DEFINE/LOCAL EXPTYPE/C/1/50  " "
DEFINE/LOCAL TRUEid/C/1/72   " "
DEFINE/LOCAL ProgId/C/1/10   " "
DEFINE/LOCAL arp/C/1/140     " "
define/local FEROSROModeStr/c/1/30    " " ? +lower_levels
define/local obyopref/c/1/30 " "
define/local initprg/c/1/50  " "
!
! sort incoming file into
! Flatfield, ThAr, Dark, and Objects catalogues according
! to image descriptor EXPTYPE and SHSTAT

i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "{infile}"
i = m$existd("{infile}","ARCFILE")
if i .eq. 1 ARCFILE = "{{infile},ARCFILE}"
$ [ -e .Red-{ARCFILE(1:29)}.Pending ] && rm -f .Red-{ARCFILE(1:29)}.Pending

i = m$existk("RedAllIms")
if i .eq. 0 define/local RedAllIms/c/1/1 "n"
!! To enable type:
!! write/key RedAllIms/c/1/1 "Y"

!!
!! Since P74, CalPlan Science Exposures such as SolarSpectra and SpecPhot
!! Standards have DPR.CATG set to CALIB, which also sets OBJECT to DPR.TYPE.
!!
TRUEid = "{{infile},IDENT}"
i = m$existd("{infile}","ESO.OBS.TARG.NAME")
if i .eq. 1 TRUEid = "{{infile},ESO.OBS.TARG.NAME}"
!
i = m$existd("{infile}","ESO.OBS.PROG.ID")
if i .eq. 1 ProgId = "{{infile},ESO.OBS.PROG.ID}"

i = m$existd("{infile}","SHSTAT")
if i .eq. 1 THEN
!! Probably a BIAS generated image...
  WRITE/OUT "{infile} seems to be a BIAS generated image..."
  if "{{infile},SHSTAT}" .eq. "CLOSED"  then
    write/descr {infile} EXPTYPE/C/1/12 "DARK        "
    add/icat Dark.cat {infile}
    EXPTYPE = "DARK"
  elseif "{{infile},SHSTAT}" .eq. "OPEN"  then
    i = m$existd("{infile}","ESO.INS.DID")
    if i .eq. 1 then
  !! Must be a FEROS-II:Commissioning-VI image...
      if "{{infile},ESO.INS.SCSM.NAME}" .NE. "BOTHFIBS" then 
        add/icat Objects {infile}
        if "{TRUEid}" .eq. "SolarSpectrum" then
          i = m$exist("sol.cat")
          if i .eq. 0 then
            creat/icat sol.cat {infile}
          else
            add/icat sol.cat {infile}
          endif
        endif
        EXPTYPE = "SCIENCE"
      elseif "{{infile},ESO.INS.RSM.NAME}" .eq. "LAMP2" then
        add/icat FF {infile}
        EXPTYPE = "FLATFIELD"
      elseif "{{infile},ESO.INS.RSM.NAME}" .eq. "LAMP1" then
        add/icat ThAr {infile}
        EXPTYPE = "CALIBRATION"
      endif
    else
      if "{{infile},EXPTYPE}" .eq. "CALIBRATION" then
        add/icat ThAr {infile}
      elseif "{{infile},EXPTYPE}" .eq. "FLATFIELD" then
        add/icat FF {infile}
      elseif "{{infile},EXPTYPE}" .eq. "SCIENCE" then 
        add/icat Objects {infile}
        if "{TRUEid}" .eq. "SolarSpectrum" then
          i = m$exist("sol.cat")
          if i .eq. 0 then
            creat/icat sol.cat {infile}
          else
            add/icat sol.cat {infile}
          endif
        endif
      endif
      EXPTYPE = "{{infile},EXPTYPE}"
    endif
  endif
else
!! Probably a FIERA generated image...
  WRITE/OUT "{infile} seems to be a FIERA generated image..."
  ISSCIENCE = 0
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJ,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJ,CAL" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJECT,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJECT,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJECT,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,OBJECT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,OBJECT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,OBJECT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLUX" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,FLUX" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,FLUX" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,VELOC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,VELOC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,VELOC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,TELLURIC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,TELLURIC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,TELLURIC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,SKY" ISSCIENCE = 1
  ISSTD = 0
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,STD" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,STD" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLUX" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,FLUX" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,FLUX" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,VELOC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,VELOC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,VELOC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,TELLURIC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,TELLURIC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,TELLURIC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,SKY" ISSTD = 1
  if ISSCIENCE .eq. 1 then
    if "{TRUEid}" .eq. "SolarSpectrum" then
      i = m$exist("sol.cat")
      if i .eq. 0 then
        creat/icat sol.cat {infile} ESO.OBS.TARG.NAME
      else
        add/icat sol.cat {infile}
      endif
      show/icat sol.cat
    else
      if "{{infile},ESO.DPR.CATG}" .eq. "CALIB" ISSTD = 1
      if ISSTD .eq. 1 then
        i = m$exist("std.cat")
        if i .eq. 0 then
          creat/icat std.cat {infile} ESO.OBS.TARG.NAME
        else
          add/icat std.cat {infile}
        endif
        show/icat std.cat
      else
        add/icat Objects {infile}
        show/icat Objects.cat
      endif
    endif
    EXPTYPE = "SCIENCE"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_bias" then
    add/icat Bias.cat {infile}
    EXPTYPE = "Bias"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_flat" then
    add/icat FF {infile}
    EXPTYPE = "Hal+Hal Flatfield"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_wave" then
    add/icat ThAr {infile}
    EXPTYPE = "ThArNe Wavelength Calibration"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_dark" then
    i = m$exist("Dark.cat")
    if i .eq. 0 then
      creat/icat Dark.cat {infile}
    else
      add/icat Dark.cat {infile}
    endif
    show/icat Dark.cat
    EXPTYPE = "Dark"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_ThAr_Ne" then
    i = m$exist("ThArNe.cat")
    if i .eq. 0 then
      creat/icat ThArNe.cat {infile}
    else
      add/icat ThArNe.cat {infile}
    endif
    show/icat ThArNe.cat
    EXPTYPE = "ThAr+Ne Wavelength Calibration"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_df" then
    i = m$exist("DF.cat")
    if i .eq. 0 then
      creat/icat DF.cat {infile}
    else
      add/icat DF.cat {infile}
    endif
    show/icat DF.cat
    EXPTYPE = "Dome FlatField"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_D2" then
    i = m$exist("D2Hal.cat")
    if i .eq. 0 then
      creat/icat D2Hal {infile}
      show/icat D2Hal
    else
      add/icat D2Hal {infile}
      show/icat D2Hal
    endif
    EXPTYPE = "D2+Hal FlatField"
  else
    WRITE/OUT "Warning!!! Exposure type NOT recogonised."
    $ ferosQCWarningOrError E "Red-{ARCFILE(1:29)}" autoreduce.prg "Exposure type NOT recogonised."
    goto exit
  endif
  FIBSEL = "1"
  i = m$existd("{infile}","ESO.TEL.AG.FIBSELEC")
  if i .eq. 1 then
    if "{{infile},ESO.TEL.AG.FIBSELEC}" .eq. "SKYFIB" FIBSEL = "2"
  endif
endif

write/out "--------------------------------------------"
write/out "{infile}: Exposure type {EXPTYPE} "
write/out "--------------------------------------------"
!
symMkHTML = m$symbol("FEROSmkHTML")
if "{symMkHTML}" .EQ. "Y" then
  $ ferosMkHTML.pl -a add {infile}
endif
!
! for SCIENCE frames do standard reduction:
!
if "{EXPTYPE}" .eq. "SCIENCE" .OR. "{RedAllIms}" .eq. "Y" then

!! Output FITS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
  i = m$existk("UseAFDRSFITS")
  if i .ne. 1 then
    DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
    UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
  endif
!
! GAIN and RON now set in separate MIDAS routine ferosSetRONandGAIN.prg
  write/out 
  @@ ferosSetRONandGAIN {infile}
!
!! AutoInit detection
!
  i = m$existk("symAutoInit")
  if i .ne. 1 then
    define/local symAutoInit/c/1/1 " "
    symAutoInit = m$symbol("FEROSAutoInit")
  endif
  if "{symAutoInit}" .EQ. "Y" then
    write/out " "
    write/out " ***** "
    write/out "Trying to find appropriate INIT"
    write/out "This will overwrite any manual settings of FEROS parameters"
    write/out "To disable type:"
    write/out "    write/key symAutoInit/c/1/1 "N"
    write/out " ***** "
    write/out " "
    i = m$exist("Init-DEFAULT.prg")
    if i .eq. 1 initprg = "Init-DEFAULT.prg"
    i = m$exist("Init-DEFAULT_{FEROSROModeStr(14:16)}.prg")
    if i .eq. 1 initprg = "Init-DEFAULT_{FEROSROModeStr(14:16)}.prg"
    i = m$exist("Init-{FEROSROModeStr}.prg")
    if "{initprg(1:1)}" .ne. " " @@ {initprg}
  endif
!
!
! pre-reduction
!
  i = m$exist("raw_image.bdf")
  if i .eq. 1 $ rm -f raw_image.bdf
  @@ prered {num} raw_image
  i = m$exist("raw_image.bdf")
  if i .ne. 1 then
    write/out "autoreduce.prg: Error!!! prered.prg failed (raw_image.bdf does not exist)"
    write/out "autoreduce.prg: Can not continue for this file fero{num}.mt"
    $ ferosQCWarningOrError E "Red-{ARCFILE(1:29)}" autoreduce.prg "prered.prg failed to create raw_image.bdf."
    goto exit
  endif

! convert RA in Hours Minutes Seconds
!
  ra = {raw_image,o_pos(1)}
  ra = ra/15.

! compute barycentric velocity
!
  if "{EXPTYPE}" .eq. "SCIENCE" then

    comp/bary raw_image.bdf {ra} {raw_image,o_pos(2)}
    write/desc raw_image bary_corr/r/1/1 {outputr(1)}

  else

    write/out "ZERO Barycentric Correction for {EXPTYPE} image..."
    write/out "Image descriptor bary_corr set to 0.0"
    write/desc raw_image bary_corr/r/1/1 0.0

  endif

! reduction starts here
!
  i = m$existk("dark")
  if i .eq. 0 define/local dark/c/1/1 "N"
  if "{dark}" .EQ. "D" then    ! dark-subtraction

    etime = {{infile},o_time(7)}
    comp sub_image = raw_image-DARK*{etime}/3600
    BACKGR/FEROS sub_image back

  else

    BACKGR/FEROS raw_image back

  endif

  RECTIFY/FEROS back back_str
  if "{ARCFILE(1:1)}" .ne. " " .and. "{UseAFDRSFITS}" .EQ. "Y" then
    outdisk/fits back_str_C1.bdf r.{ARCFILE(1:29)}.0011.fits
    outdisk/fits back_str_D1.bdf r.{ARCFILE(1:29)}.0021.fits
    outdisk/fits back_str_X1.bdf r.{ARCFILE(1:29)}.0031.fits
    outdisk/fits back_str_C2.bdf r.{ARCFILE(1:29)}.0012.fits
    outdisk/fits back_str_D2.bdf r.{ARCFILE(1:29)}.0022.fits
    outdisk/fits back_str_X2.bdf r.{ARCFILE(1:29)}.0032.fits
  endif

  host = m$symbol("HOST")
  arp = "autoreduce_plots"
  i = m$exist("MID_WORK:autoreduce_plots.prg.{host}")
  if i .eq. 1 arp = "autoreduce_plots.prg.{host}"
  i = m$exist("MID_WORK:autoreduce_plots.prg.{ProgId}")
  if i .eq. 1 arp = "autoreduce_plots.prg.{ProgId}"
  i = m$exist("MID_WORK:autoreduce_plots.prg.{TRUEid}")
  if i .eq. 1 arp = "autoreduce_plots.prg.{TRUEid}"

  if EXT_MODE(1:1) .EQ. "B" then
    @@ standard {num}
    @@ {arp} {num} {fibsel} f
    @@ optimum {num}
    @@ {arp} {num} {fibsel} o
    SET/FERO EXT_MODE=BOTH

  elseif EXT_MODE(1:1) .EQ. "O" then
    @@ optimum {num}
    @@ {arp} {num} {fibsel} o

  else  	
    @@ standard {num}
    @@ {arp} {num} {fibsel} f

  endif

  i = m$existk("FEROSmkOrderByOrderPlots")
  if i .eq. 1 then
    if "{FEROSmkOrderByOrderPlots}" .ne. "N" then
      if "{host}" .eq. "w2p2off" then
        $ xterm -iconic -fn 8x16 -display :0.1 -e kstart --desktop 3 --activate "xterm -geometry 1x1-0-0 -e sleep 1"
        assi/grap G,9
      endif
      obyopref = "o"
      if "{FEROSmkOrderByOrderPlots}" .ne. "Y" obyopref = "{FEROSmkOrderByOrderPlots}o"
      i = m$exist("f{num}{fibsel}.bdf")
      if i .eq. 1 @@ ferosPlotOrderByOrder {num} {fibsel} {obyopref}
      obyopref = "f"
      if "{FEROSmkOrderByOrderPlots}" .ne. "Y" obyopref = "{FEROSmkOrderByOrderPlots}f"
      i = m$exist("o{num}{fibsel}.bdf")
      if i .eq. 1 @@ ferosPlotOrderByOrder {num} {fibsel} {obyopref}
      if "{host}" .eq. "w2p2off" then
        $ xterm -iconic -fn 8x16 -display :0.1 -e kstart --desktop 1 --activate "xterm -geometry 1x1-0-0 -e sleep 1"
        assi/grap G,0
      endif
    endif
  endif

  if "{symMkHTML}" .EQ. "Y" then
    $ ferosMkHTML.pl -a mklink {infile}
  endif
else
  $ touch .Red-{ARCFILE(1:29)}.Pending
endif

$ ferosQCWarningOrError O "Red-{ARCFILE(1:29)}" autoreduce.prg "Reduction completed"

exit:
