! @@ autoreduce_plots.prg	  
! "@(#) $Id: autoreduce_plots.prg,v 1.13 2005/10/17 12:13:27 jpritcha Exp $"
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  autoreduce_plots.prg	  
! J.D.Pritchard <j.pritchard@eso.org> 2003-01-20
!
! USAGE
!
! @@ autoreduce_plots.prg <NNNN> <fibre> <f|o>
!
! with : <NNNN> 	:  1-d spectrum file number
!        <fibre>	:  1=Object or 2=Sky
!        <f|o>  	:  1-d spectrum file prefix normally f or o
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1  ?   C "1-d spectrum file number (e.g. 0020) : "
define/par p2  1   C "Fibre (1|2) : "
define/par p3  f   C "Prefix [f] : "
!
define/local i/i/1/1 0
define/local order/i/1/1 0
define/local lstart/r/1/1 0.0
define/local lend/r/1/1 0.0
define/local host/c/1/10    " "
define/local OFLABEL/C/1/100 " "

i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "{p3}{p1}{p2}"
i = m$exist("{p3}{p1}{p2}.bdf")
if i .eq. 1 then
  i = m$existd("{p3}{p1}{p2}","ARCFILE")
  if i .eq. 1 ARCFILE = "{{p3}{p1}{p2},ARCFILE}"
endif
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif
OFLABEL = "{p3}{p1}{p2}"
if "{ARCFILE}" .ne. "{p3}{p1}{p2}" .and. "{UseAFDRSFITS}" .EQ. "Y" OFLABEL = "r.{ARCFILE(1:29)}.{P2}"
!
host = m$symbol("HOST")
if "{host}" .eq. "w2p2off" then
  $ xterm -fn 8x16 -display :0.1 -e kstart --desktop 1 --activate "xterm -e sleep 1"
endif
set/grap default
set/grap pmode=1 font=1
if MERGE_MTD(1:1) .EQ. "N" then
! ######################################################
! Spectrum was NOT merged... i.e. order by order...
! ######################################################
  i = m$exist("{p3}{p1}{p2}0001.bdf")
  if i .ne. 1 then
    write/out "Error!!! Can NOT find file {p3}{p1}{p2}0001.bdf."
    goto aorr
  endif
! Full range (almost...)
  assi/grap G,0
  set/grap xaxis=4000,9650 yaxis=0.0,2.0
  plot/axes ? ? ? "Wavelength [\AA]"
  i = 0
  do order = {ORDER_FIRST} {ORDER_LAST} 1
    i = i+1
    lstart = {{p3}{p1}{p2}{i},START(1)}
    lend   = {{p3}{p1}{p2}{i},START(1)}+{{p3}{p1}{p2}{i},NPIX(1)}*{{p3}{p1}{p2}{i},STEP(1)}
    if 4000 .lt. {lstart} .and. 9650 .gt. {lend} then
      write/out "Reduced order {i}/[m={order}], {lstart}-{lend}"
      overplot {p3}{p1}{p2}{i} ?
    endif
  enddo
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}.ps
  set/grap xaxis=auto yaxis=auto
! Order 20
  assi/grap G,1
  plot {p3}{p1}{p2}0017 ?
  label/grap "Order 17 (H\{\_\beta \})" 35,17,mm ? 2 1
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}0017.ps
! Order 21
  assi/grap G,2
  plot {p3}{p1}{p2}0018 ?
  label/grap "Order 18 (H\{\_\beta \})" 35,17,mm ? 2 1
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}0018.ps
! Order 29
  assi/grap G,3
  plot {p3}{p1}{p2}0029 ?
  label/grap "Order 29 (H\{\_\alpha \})" 35,17,mm ? 2 1
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}0029.ps
! Order 30
  assi/grap G,4
  plot {p3}{p1}{p2}0030 ?
  label/grap "Order 30 (H\{\_\alpha \})" 35,17,mm ? 2 1
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}0030.ps
  set/grap default
else
! ######################################################
! Spectrum was merged...
! ######################################################
  i = m$exist("{p3}{p1}{p2}.bdf")
  if i .ne. 1 then
    write/out "Error!!! Can NOT find file {p3}{p1}{p2}.bdf."
    goto aorr
  endif
  cut {p3}{p1}{p2} 0,0
! Full range
  assi/grap G,0
  set/grap xaxis=3500,9250,500,100
  plot {p3}{p1}{p2} ?
  set/grap xaxis=default
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}.ps
! H-alpha 
  assi/grap G,1
  plot {p3}{p1}{p2} ? 6520,6600
  label/grap "H\_\alpha" 35,17,mm ? 2 1
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}-Ha.ps
! H-beta
  assi/grap G,2
  plot {p3}{p1}{p2} ? 4820,4900
  label/grap "H\{\_\beta \}+He" 35,17,mm ? 2 1
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}-Hb.ps
endif

aorr:
assi/grap G,0
