! %W% (ESO-IPG) %G% %U%
!==========================================================================
!
!    efficiency_cat.prg
!    J.Pritchard, ESO-LS, 2002-11-22
!
!    Compute FEROS efficiency + telescope + fibres
!
!    Syntax:  @@ efficiency_cat catalogue-name.cat
!
!###########################################################################

def/par P1 Objects.cat                         CHAR "Objects catalogue filename : "
def/par P2 MIDASHOME:/calib/data/spec/ctio     CHAR "Spectral flux directory"

DEFINE/LOCAL CATAL/I/1/1   0
define/local etime/D/1/1   0
define/local i/i/1/1       0
define/local ident/c/1/40  " "
define/local infile/c/1/60 " " all
define/local j/i/1/1       0
define/local k/i/1/1       0
define/local lend/r/1/1    0.0
define/local lstart/r/1/1  0.0
define/local num/c/1/4     " " all
define/local order/i/1/1   0
define/local ra/d/1/1      0.0
define/local rebstep/r/1/2 0.0

next:
store/frame infile {p1} 1 done

  i = m$existd("{infile}","CIDENT")
  j = m$existd("{infile}","OBJECT")
  k = m$existd("{infile}","IDENT")
  if i .eq. 1 then
    write/key ident "{{infile},CIDENT}"
  elseif j .eq. 1 then
    write/key ident "{{infile},OBJECT}"
  elseif k .eq. 1 then
    write/key ident "{{infile},IDENT}"
!!
!! Since P74, CalPlan Science Exposures such as SolarSpectra and SpecPhot
!! Standards have DPR.CATG set to CALIB, which also sets OBJECT to DPR.TYPE.
!!
    i = m$existd("{infile}","ESO.OBS.TARG.NAME")
    if i .eq. 1 ident = "{{infile},ESO.OBS.TARG.NAME}"
  endif

!
! Work out which fibre was used...
i = m$existk("FEROSObjFib")
if {i} .eq. 0 then
  define/local FEROSObjFib/C/1/1 "1"
  i = m$existd("{infile}","ESO.TEL.AG.FIBSELEC")
  if i .eq. 1 then
    if "{{infile},ESO.TEL.AG.FIBSELEC}" .eq. "SKYFIB" FEROSObjFib = "2"
  endif
endif

  ident = m$lower("{ident}")

  i = m$exist("{P2}/{ident}.tbl")
  if i .eq. 1 then
    write/key num/c/1/4 {infile(5:8)}
    @@ autoreduce_plots f{num} {FEROSObjFib}
    @@ efficiency {num} {ident} {FEROSObjFib} {p2}
  endif

goto next

done:

exit:
