! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: efficiency_plots.prg,v 1.15 2005/11/26 08:33:41 jpritcha Exp $"
!==========================================================================
!
!    efficiency_plots.prg
!###########################################################################

def/par P1 ? I "Enter object frame number: "
def/par P2 ? I "       Standard star name: "
def/par P3 1 N "Fibre (1) : "
def/par P4 Y C "Plot to graphic window : "
def/par P5 N C "Make QC dat files (y/N) : "

def/local i/i/1/1           0
def/local EMPREF/c/1/2      " "
def/local EFFLINE/r/1/1     0.
def/local ordb/r/1/2        0.,0.
define/local order/i/1/1    0
define/local epe/r/1/1      0.
define/local wepe/r/1/1     0.
define/local host/c/1/100   " "
define/local fitCos/r/1/9   0.,0.,0.,0.,0.,0.,0.,0.,0.
define/local wlr/r/1/1      0.
define/local inte/r/1/1     0.
define/local focoff/d/1/1   0.
define/local TLS/r/1/1      0.
define/local OFLABEL/C/1/100 " "
define/local etab/c/1/100    " "
define/local catal/i/1/1   0

i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "fero{p1}.mt"
i = m$existd("fero{p1}.mt","ARCFILE")
if i .eq. 1 ARCFILE = "{fero{p1}.mt,ARCFILE}"
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif
OFLABEL = "efficiency{P1}{P3}"
if "{ARCFILE}" .ne. "fero{p1}.mt" .and. "{UseAFDRSFITS}" .EQ. "Y" OFLABEL = "r.{ARCFILE(1:29)}.{P3}_eff"

host = m$symbol("HOST")
set/format i4
if "{p4}" .ne. "n" then
  if "{host}" .eq. "w2p2off" then
    $ xterm -iconic -fn 8x16 -display :0.1 -e kstart --desktop 3 --activate "xterm -geometry 1x1-0-0 -e sleep 1"
    assi/grap G,6
  endif
  set/grap default
  set/graph pmode=1 xaxis=auto yaxis=auto font=1
  plo/ax 3500,9650,1000,200 -0.01,0.25  ? "Wavelength [\AA ]" "Efficiency of Tel+Fib+Inst+Det"
endif
i = 0
do order = {ORDER_FIRST} {ORDER_LAST} 1
  i = i+1
  ordb(1) = i - 0.05
  ordb(2) = i + 0.05
  set/midas output=no
  sele/tabl efficiency{p1}{P3} :order.gt.{ordb(1)}.and.:order.lt.{ordb(2)}
  stat/tabl efficiency{p1}{P3} :wave{p3}
  merg/tabl efficiency{p1}{P3} effMaxTmp2
  sort/tabl effMaxTmp2 :eff{P3}(-)
  sele/tabl effMaxTmp2 seq.eq.2
  if i .eq. 1 then
    merg/tabl effMaxTmp2 efficiency{p1}{P3}ordMax
  else
    merg/tabl efficiency{p1}{P3}ordMax effMaxTmp1
    merg/tabl effMaxTmp1 effMaxTmp2 efficiency{p1}{P3}ordMax
  endif
  set/midas output=yes
  write/out "Order {i}/[{order}] {outputr(1)} -- {outputr(2)}"
  if "{p4}" .ne. "n" over/tabl efficiency{p1}{P3} :wave{P3} :eff{P3} ? 1 1
enddo
regr/poly efficiency{p1}{P3}ordMax :eff{P3} :wave{P3} 8
copy/kk outputr/r/1/7 fitCos/r/1/7
save/regr efficiency{p1}{P3}ordMax EFFCO
comp/regr efficiency{p1}{P3}ordMax :fit{P3} = EFFCO
set/grap colour=4
if "{p4}" .ne. "n" over/tabl efficiency{p1}{P3}ordMax :wave{P3} :fit{P3} ? 1 1
set/grap colour=1
set/midas output=no
sort/tabl efficiency{p1}{P3}ordMax :fit{P3}(-)
stat/tabl efficiency{p1}{P3}ordMax :fit{P3}
epe  = OUTPUTR(2) * 100.0
wepe = {efficiency{p1}{P3}ordMax,:wave1,@1}
wlr  = 9000 - 4000
inte =        fitCos(1)/1. * wlr
inte = inte + fitCos(2)/2. * wlr * wlr
inte = inte + fitCos(3)/3. * wlr * wlr * wlr
inte = inte + fitCos(4)/4. * wlr * wlr * wlr * wlr
inte = inte + fitCos(5)/5. * wlr * wlr * wlr * wlr * wlr
inte = inte + fitCos(6)/6. * wlr * wlr * wlr * wlr * wlr * wlr
inte = inte + fitCos(7)/7. * wlr * wlr * wlr * wlr * wlr * wlr * wlr
inte = inte + fitCos(8)/8. * wlr * wlr * wlr * wlr * wlr * wlr * wlr * wlr
inte = inte + fitCos(9)/9. * wlr * wlr * wlr * wlr * wlr * wlr * wlr * wlr * wlr
inte = inte / 6.0E+15
sort/tabl efficiency{p1}{P3}ordMax :wave{P3}
set/midas output=yes
set/format F4.1
write/out "Estimated Peak Efficiency: {epe}% at {wepe} AA "
set/format F5.3
write/out "Integrated Efficiency [4000 -- 9000]: {inte}"
set/format

i = m$existd("f{P1}{P3}.mt","focOff")
i = 0
if i .ne. 1 then
!! Focus equation is:
!! Foc[Theo] = 23740.0 - 66.0 * T[LS] + 2.0 * ZD + FO
!! --> FO = Foc[Theo] - 23740.0 + 66.0 * T[LS] - 2.0 * ZD
!! Foc[Theo] = HIERARCH ESO TEL FOCU VALUE
!! T[LS] = HIERARCH ESO TEL TSS TEMP7 START
!! ZD = 90.0 - HIERARCH ESO TEL ALT
  i = m$existd("f{p1}{p3}.mt","ESO.TEL.ALT") * m$existd("f{p1}{p3}.mt","ESO.TEL.FOCU.VALUE")
  i = i * m$existd("f{p1}{p3}.mt","ESO.TEL.TSS.TEMP7.START") * m$existd("f{p1}{p3}.mt","ESO.TEL.TSS.TEMP7.END")
  if i .eq. 1 then
    TLS = ( {f{p1}{p3}.mt,ESO.TEL.TSS.TEMP7.START} + {f{p1}{p3}.mt,ESO.TEL.TSS.TEMP7.END}) / 2.0
    focOff =  {f{p1}{p3}.mt,ESO.TEL.FOCU.VALUE} - 23740.0 + 66.0 * TLS - 2.0 * (90. - {f{P1}{P3}.mt,ESO.TEL.ALT} )
    write/out "Computed Focus Offset = {focOff}"
  else
    write/out "Warning!!! Do NOT know how to determine Focus Offset."
    focOff = 9999.
  endif
else
  copy/dk f{P1}{P3}.mt focOff/d/1/1 focOff
  write/out "Focus Offset from Descriptor = {focOff}"
endif

write/desc efficiency{p1}{P3}.tbl MeasdEff/r/1/4 {focOff},{wepe},{epe},{inte}
if "{P5}" .eq. "Y" then
  $ echo ferosUpdateEfficiencyDB f{P1}{P3} {focOff} {wepe} {epe} {inte}
  $ ferosUpdateEfficiencyDB f{P1}{P3} {focOff} {wepe} {epe} {inte}
endif

sele/tabl efficiency{p1}{P3} all

if "{p4}" .ne. "n" then
  label/gra "FEROS efficiency test: Fibre {P3} (input files: fero{p1}.mt, {p2})" 3500,0.260 0 1 1
  do i = 1 25
    effline = i * .01
    over/line 1 3500,{EFFLINE} 9650,{EFFLINE}
    effline = i * .01 - 0.005
    over/line 2 3500,{EFFLINE} 9650,{EFFLINE}
  enddo
  copy/grap postscript
  $ mv postscript.ps {OFLABEL}.ps
  set/gra xa
!endif

!if "{host}" .eq. "w2p2off" then
  crea/tcat efficiencyordMax.cat efficiency*ordMax.tbl
  assi/grap G,7
  set/grap default
  set/graph pmode=1 xaxis=auto yaxis=auto font=1
  plot/axes 3500,9650,1000,200 -0.01,0.25 ? "Wavelength [\AA]" "Efficiency"
  set/grap colour=2 ltype=1 lwidth=1
  next:
  store/frame etab efficiencyordMax.cat 1 done
    over/table {etab} :wave{P3} :fit{P3} ? 1 1
  goto next
  done:
  set/grap colour=1 ltype=1 lwidth=3
  over/table efficiency{p1}{p3}ordMax :wave{P3} :fit{P3} ? 1 1
  set/grap lwidth=1
  do i = 1 25
    effline = i * .01
    over/line 1 3500,{EFFLINE} 9650,{EFFLINE}
    effline = i * .01 - 0.005
    over/line 2 3500,{EFFLINE} 9650,{EFFLINE}
  enddo
  set/grap default
endif
set/format
