! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: ferosFFMaxADU.prg,v 1.1 2005/08/18 23:54:32 jpritcha Exp $"
!==========================================================================
!
!    ferosFFMaxADU.prg
!    J.Pritchard, ESO-LS, 2004-11-16
!
!    Compute and S/N ratios in FFs order by order centered on the blaze
!    wavelength of each order
!
!    Syntax:  @@ ferosFFMaxADU <file prefix> <fileNumber>
!                              [Window (@2048,@2248)] [KeepAvIms (N)]
!                              [KeepALLDRSProducts (N)]
!                              [Plots (N)] [PSfiles (N)]
!                              [Final/Working Graph Window IDs (5,9)]
!
!###########################################################################

define/par p1 ?     CHAR "Enter fileprefix : "
define/par p2 ?     N    "Enter filenumber : "
define/par p3 @2048,@2248 CHAR "Window definition [@2048,@2248] : "
define/par p4 N     C "Keep average Images (y/N) : "
define/par p5 N     C "Keep ALL DRS products (y/N) : "
define/par p6 N     C "Plot : "
define/par p7 N     C "Make PS files : "
define/par p8 5,9   C "Final/Working Graph Window IDs (5,9) : "


define/local iord/i/1/1 0
define/local iordsf/i/1/2 0,0
define/local mord/i/1/1 0
define/local maxADU1/r/1/1 0.
define/local maxADU2/r/1/1 0.
define/local maxADUr/r/1/1 0.
define/local gwids/i/1/2   {p8}

@@ ferosTraceOrderInSingleFlat {P1} {P2}
init/feros f{P2}
BACKGR/FEROS {RAW_IMG} back
RECTIFY/FEROS back back_str
av/col f{P2}1av = back_str_C1 {p3}
av/col f{P2}2av = back_str_C2 {p3}
writ/desc f{p2}1av.bdf GlobalMaxADU/r/1/1 -1.
writ/desc f{p2}2av.bdf GlobalMaxADU/r/1/1 -1.
stat/imag f{P2}1av p5=FNYN
copy/kd outputr/r/2/1 f{p2}1av.bdf GlobalMaxADU/r/1/1
maxADU1 = outputr(2)
stat/imag f{P2}2av p5=FNYN
copy/kd outputr/r/2/1 f{p2}2av.bdf GlobalMaxADU/r/1/1
maxADU2 = outputr(2)
maxADUr = maxADU1/maxADU2
set/format i02 f7.1
write/out "GlobalMaxADUs [{p3}]: Obj/Sky = {maxADU1}/{maxADU2} (ratio = {maxADUr})"
write/out "++++++++++++++++++++++++++++++++++++++"

!! Initialize maxADU descriptor values
writ/desc f{p2}1av.bdf maxADU/r/1/39 -1. all
writ/desc f{p2}2av.bdf maxADU/r/1/39 -1. all

!do iord = {osf(1)} {osf(2)}
!do iord = 1 39
!! Order 39 skipped because for reasons I do not yet understand the spectrum
!! is in the fisrt columns
do iord = 1 38
  set/format i1
  mord =  ORDER_LAST - iord + 1
  iordsf(1) = (iord - 1) * PROFILE_W +1
  iordsf(2) = iord * PROFILE_W
  set/format
  set/midas output={p4}
  stat/imag f{p2}1av [@{iordsf(1)}:@{iordsf(2)}] p5=FNYN
  copy/kd outputr/r/2/1 f{p2}1av.bdf maxADU/r/{iord}/{iord}
  maxADU1 = outputr(2)
  stat/imag f{p2}2av [@{iordsf(1)}:@{iordsf(2)}] p5=FNYN
  copy/kd outputr/r/2/1 f{p2}2av.bdf maxADU/r/{iord}/{iord}
  maxADU2 = outputr(2)
  set/midas output=yes
  maxADUr = maxADU1/maxADU2
  set/format i02 f7.1
  write/out "MaxADU in Order {iord} [m={mord}] [{p3}] [@{iordsf(1)}:@{iordsf(2)}]: Obj/Sky = {maxADU1}/{maxADU2} (ratio = {maxADUr})"
  set/format
enddo

if "{p5}" .eq. "y" then
  set/format i1
  assi/grap G,{gwids(1)}
  set/format
  set/grap default
  set/grap pmode=1 font=1
  set/grap xax=24,64 yax=0,1000
  plot/axes 24,64,5,1 0,1000,100,50 ? "m-Order" "S/N"
  @@ ferosSetGrapXax 0 40
  label/grap "S/N ratio at blaze wavelengths for f{p2}1 (blue) and f{p2}2 (red)" 0.5,0.975,no ? 0.7 0
  set/grap color=4
  overplot/desc f{p2}1 snr
  set/grap color=2
  overplot/desc f{p2}2 snr
  set/grap default
  if "{p6}" .eq. "y" then
    copy/grap postscript.l
    $ mv postscript.ps f{p2}-snr.ps
  endif
endif

if "{p4}" .ne. "y" then
  $ \rm -f f{p2}1av.bdf f{p2}2av.bdf
endif

if "{p5}" .ne. "y" then
!  $ \rm -f 
endif
