! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: ferosPlotOrderByOrder.prg,v 1.2 2005/10/04 21:54:29 jpritcha Exp $"
!==========================================================================
!
!    ferosResponse.prg
!    J.Pritchard, ESO-LS, 2005-08-30
!
!    Compute the response function from observation of SpecPhotStandard
!
!    Syntax:  @@ ferosPlotOrderByOrder <frame> [Y-axis range (auto)]
!
!###########################################################################

define/par p1  ?   C "1-d spectrum file number (e.g. 0020) : "
define/par p2  1   C "Fibre (1|2) : "
define/par p3  f   C "Prefix [f] : "
define/par p4 auto char "yaxis range : "

define/local i/i/1/1  0
define/local j/i/1/1  0
define/local k/i/1/1  0
define/local OFLABEL/C/1/100 " "
define/local mtfits/c/1/4    "mt"
define/local host/c/1/100   " "

i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "fero{p1}.mt"
i = m$existd("fero{p1}.mt","ARCFILE")
if i .eq. 1 ARCFILE = "{fero{p1}.mt,ARCFILE}"
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif
OFLABEL = "{p3}{p1}"
if "{ARCFILE}" .ne. "fero{p1}.mt" .and. "{UseAFDRSFITS}" .EQ. "Y" then
  mtfits = "fits"
  OFLABEL = "r.{ARCFILE(1:29)}.{p3}."
endif


set/format i4
set/grap default
set/grap pmode=1 font=1
set/grap yax={p4}

do i = 1 39
  j = i-1
  k = i+1
  if i .eq. 38 set/grap xax=8520,8920
  if i .eq. 39 set/grap xax=8840,9240

!! Fibre 1
  set/grap color=1
  plot {p3}{p1}{p2}{i}
  set/grap color=4
  if j .gt. 0 over {p3}{p1}{p2}{j}
  set/grap color=2
  if k .lt. 40 over {p3}{p1}{p2}{k}
  set/grap color=1
  over {p3}{p1}{p2}{i}
  copy/grap postscript.l
  $ mv postscript.ps {OFLABEL}{p2}{i}.ps
!! Following now done by ferosMkHtML.pl and included in web pages...
!  $ /usr/bin/convert -rotate 90 {OFLABEL}1{i}.ps {OFLABEL}1{i}.png
!  $ /usr/bin/convert -rotate 90 -resize 300x208 {OFLABEL}1{i}.ps {OFLABEL}1{i}-300x208.png
!  if "{OFLABEL}" .ne. "{p3}{p1}" then
!    $ ( for file in {OFLABEL}1{i}-300x208.png ; do mv ${file} ${file//:/_} ; done )
!  endif

enddo



