! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: ferosPlotTemplateT.prg,v 1.3 2005/10/27 13:21:36 jpritcha Exp $"
!==========================================================================
!
!    ferosPlotTemplateT.prg
!    J.Pritchard, ESO-LS, 2004-06-22
!
!    Compute and display image ratios
!
!    Syntax:  @@ ferosPlotTemplateT [templatet.bdf]
!                            [StartOrder,EndOrder] [MakePSfiles]
!                            [Landscape/Portrait]
!
!###########################################################################

define/par p1 templatet     I "RAW image (without extension, normally FF<NNNN>) : "
define/par p2 25,63 C "Order range : "
define/par p3 N     C "Make PS files : "
define/par p4 p     C "Landscape/Portrait (l/p) : "
define/par p5 _templatet C "Suffix (_templatet) : "

define/local i/i/1/1    0
define/local j/i/1/1    0
define/local mord/i/1/1 0
define/local osf/i/1/2  {p2}
define/local yaxsf/r/1/2 0.9,1.1
define/local ytick/r/1/1 0.
define/local fib/c/1/1   "{P5}"

define/local OFLABEL/C/1/100 " "

i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "{p1}.mt"
i = m$existd("{p1}.mt","ARCFILE")
if i .eq. 1 ARCFILE = "{{p1}.mt,ARCFILE}"
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif
OFLABEL = "{P1}{P5}"
if "{ARCFILE}" .ne. "{p1}.mt" .and. "{UseAFDRSFITS}" .EQ. "Y" OFLABEL = "r.{ARCFILE(1:29)}_tpl"

set/format i4

  yaxsf(1) = -0.1
  yaxsf(2) = 0.36 + ( osf(2) - osf(1) ) * 0.15
  set/grap default
  set/grap pmode=1 font=1 yformat=f4.2 xformat=f4.1
!  set/grap xax=0,4103 yax={yaxsf(1)},{yaxsf(2)}
  plot/axes -1.,35.,5,1 {yaxsf(1)},{yaxsf(2)} ? "Position" "Relative Flux"
  label/grap "{p1}{p5}" 0.5,0.975,no ? 1.0 0
  do mord = {osf(1)} {osf(2)}
    if mord .ge. ORDER_FIRST .and. mord .le. ORDER_LAST then
      j = ORDER_LAST - mord + 1
      set/format i4
      @@ ferosSetGrapYax {yaxsf(1)} {yaxsf(2)}
      set/grap colour=1
!      if mord .ne. osf(2) over/line 1 -1,1.08,wo 33,1.08,wo
      over/line 2 -1,0.00,wo 35,0.00,wo
      set/grap colour=4
      overplot/row {p1}{p5} @{j}
      set/grap colour=1
      set/format i1
!      label/grap "0.00" -1.5,0.00,wo ? 0.30 2
!      label/grap "0.10" -1.5,0.10,wo ? 0.30 2
!      label/grap "0.20" -1.5,0.20,wo ? 0.30 2
!      label/grap "0.30" -1.5,0.30,wo ? 0.30 2
      label/grap "{mord}"  35.5,0.0,wo ? 0.55 1
    else
      write/out "Error!!! Order {j} [m={mord}] not between ORDER_FIRST({ORDER_FIRST}) and ORDER_LAST({ORDER_LAST})"
    endif
    yaxsf(1)  = yaxsf(1) - 0.15
    yaxsf(2)  = yaxsf(2) - 0.15
  enddo
  if "{P3}" .eq. "Y" then
    copy/grap postscript.{p4}
    $ mv postscript.ps {OFLABEL}.ps
  endif
