! "@(#) $Id: ferosProcEffFocSeq.prg,v 1.10 2005/09/27 16:00:48 jpritcha Exp $"

define/par P1 ?   n    "Enter filenumber : "
define/par p2 Add CHAR "Action (Add/Calc) : "
define/par p3 1   n    "Fibre (1) : "

def/loc OBst/c/1/19   "{f{P1}{p3},ESO.OBS.START}"
def/loc TPLst/c/1/19  "{f{P1}{p3},ESO.TPL.START}"

def/loc i/i/1/1      0
def/loc fctrl/i/1/2  0,0

def/loc focOff/r/1/1   0.
def/loc focValue/r/1/1 0.
def/loc meff/r/1/4     0.,0.,0.,0.
def/loc FO/r/1/1       0.0
def/loc maxEff/r/1/1   0.0

def/loc focCol/c/1/2 " "

if "{p2}" .eq. "Add" then

  i = m$existd("f{P1}{p3}","focOff")
  if i .ne. 1 then
    write/out "Error!!! Do NOT know how to determine Focus Offset."
    goto aorr
  endif
  copy/dk f{P1}{p3} focOff/r/1/1 focOff
  copy/dk f{P1}{p3} ESO.TEL.FOCU.VALUE/d/1/1 focValue

  i = m$exist("focusSeq-{TPLst}.dat")
  if i .ne. 1 $ touch focusSeq-{TPLst}.dat

  i = m$existd("efficiency{P1}{p3}.tbl","MeasdEff")
  if i .ne. 1 then
    write/out "Error!!! Do NOT know how to determine Measured Efficiency."
    write/out "Perhaps you need to run efficiency_plots.prg first."
    goto aorr
  endif
! Descriptor MeasdEff/r/1/4 is:
!  (1) FocOff (focus offset)
!  (2) wepe   Wavelength of Efficiency Peak
!  (3) epe    Efficiency Peak
!  (4) inte   Integrated Efficiency
  copy/dk efficiency{p1}{p3}.tbl MeasdEff/r/1/4 meff/r/1/4

  set/format
  open/file focusSeq-{TPLst}.dat APPEND fctrl
  write/file {fctrl(1)} "fero{P1}.mt {fero{P1}.mt,ARCFILE} {meff(1)} {meff(2)} {meff(3)} {meff(4)} {focValue}"
  close {fctrl(1)}
!  $ jed focusSeq-{TPLst}.dat
  crea/tabl focusSeq-{TPLst}.tbl 10 20 focusSeq-{TPLst}.dat $FEROS_DRS/fmt/FEROS-focusSeq.fmt

!  dele/grap 8
!  crea/grap 8
  set/grap default
  set/grap pmode=1 font=1
! Check to see if focOff has a range of values...
  stat/tabl focusSeq-{TPLst} :focOff
  if outputr(1) .ne. outputr(2) then
    focCol = "#3"
  else
! Probably don't know how to compute focOff and all are set to -9999, so use focValue...
    focCol = "#7"
  endif

  sort/tabl focusSeq-{TPLst} {focCol}
  plot/tabl focusSeq-{TPLst} {focCol} :PeakEff

elseif "{p2}" .eq. "Calc" then
!
! Fit curve and report optimum FO...
! fit-x computation
!
! The efficiency (y) versus focus value (x) is
! fitted by the second order polynomial
!
! y = a1 + a2*x + a3*x**2
!
! The best focus value is the value for which
! the efficiency is maximum. After calculating the
! derivaive of y with respect to x, and 
! setting it to zero we find that the x value
! that corresponds to the minimum is
! given by -a2/(2*a3), and the y value at
! the minimum is give by a1 - a2*a2/(4*a3).
! The coefficients a1, a2, and a3 are returned
! in the vector variable outputd after
! the call to comp/regression.
!
  sele/tabl focusSeq-{TPLst} all
  if outputi(1) .ge. 3 then

! Check to see if focOff has a range of values...
    stat/tabl focusSeq-{TPLst} :focOff
    if outputr(1) .ne. outputr(2) then
      focCol = "#3"
    else
! Probably don't know how to compute focOff and all are set to -9999, so use focValue...
      focCol = "#7"
    endif

    regression/polynomial focusSeq-{TPLst} :PeakEff {focCol} 2
    save/regression focusSeq-{TPLst} FOCSEQ
    comp/regression focusSeq-{TPLst} :fitEff = FOCSEQ({focCol})
    FO = ({outputd(2)}/(-2.*{outputd(3)}))
    maxEff = -{outputd(2)}*{outputd(2)}/(4.0*{outputd(3)})+{outputd(1)}

    set/grap stype=0 ltype=1 color=4
    overplot/tabl focusSeq-{TPLst} {focCol} :fitEff

! Write focus to a variable that BOB can retrieve...
    outputi(1) = M$NINT({FO})

    write/out
    write/out
    set/format ,f12.0                       !for double keywords
    write/out "**************************************************************************"
    write/out "**                                                                      **"
    write/out "**  Maximum Peak Efficiency {maxEff} at Focus Offset = {FO}  **"
    write/out "**                                                                      **"
    write/out "**************************************************************************"
    write/out "     Stored in descriptor MaxPeakEff in focusSeq-{TPLst}.tbl"
    set/format
    write/desc focusSeq-{TPLst}.tbl MaxPeakEff/r/1/2 {maxEff},{FO}

    copy/grap postscript
    $ mv postscript.ps focusSeq-{TPLst}.ps

    assi/grap G,0
  endif

else

  write/out "Error!!! Action (p2={p2}) not recognised."
  write/out "Must be one of Add or Calc."

endif

aorr:
