! "@(#) $Id: ferosProcessCCDTestImages.prg,v 1.2 2003/10/30 03:05:51 jpritcha Exp $"
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.IDENTIFICATION: ferosProcessCCDTestImages.prg    
!.PURPOSE:        Procedure to reduce a standard test
!.AUTHOR:         J.Pritchard
!.USE:            @@ ferosProcessCCDTestImages p1 p2 p3 p4 p5 p6
!.                where p1 = number of CCD
!.                      p2 = date of test (format YYMMDD)
!.                      p3 = image filename prefix
!.                      p4 = file number of last image
!.                      p5 = Number of images incl. the 5 bias
!.                      p6 = Print output
!.VERSION:      20021022 JDP creation
!      
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DEFINE/PARAMETER P1 ?            C*2  "Number of CCD:"
DEFINE/PARAMETER P2 "00000000"   C*8  "Date of test (YYYYMMDD):"
DEFINE/PARAMETER P3 "test"       C    "Image filename prefix:"
DEFINE/PARAMETER P4 25           N    "File number of last image:"
DEFINE/PARAMETER P5 25           N    "Total number of images:"
DEFINE/PARAMETER P6 Y            C*1  "Send to printer (Y/n):"
DEFINE/PARAMETER P7 DEF          CHAR "AmpGain mode string (DEF):"
DEFINE/PARAMETER P8 DEF          CHAR "Region (DEF):"

DEFINE/LOCAL AGMODE/C/1/15    " "
DEFINE/LOCAL AMPLM/C/1/2     " "
DEFINE/LOCAL GAINM/C/1/4     " "
DEFINE/LOCAL EXDNS/C/1/2     " "
DEFINE/LOCAL DIRNAME/C/1/100 " "
DEFINE/LOCAL AREGION/C/1/23  "451,411:650,610"
DEFINE/LOCAL BREGION/C/1/23  "1151,411:1350,610"
DEFINE/LOCAL REGION/C/1/23   " "
DEFINE/LOCAL ROMODE/C/1/15    " "
DEFINE/LOCAL IBDFNAME/C/1/100 " "
DEFINE/LOCAL OBDFNAME/C/1/100 " "

DEFINE/LOCAL FRNUM/I/1/1   0
DEFINE/LOCAL I/I/1/1       0
DEFINE/LOCAL J/I/1/1       0
DEFINE/LOCAL K/I/1/1       0
DEFINE/LOCAL NUMAMPS/I/1/1 1
DEFINE/LOCAL SFFRNUM/I/1/2 0,0

SFFRNUM(1) = {P4} - {P5} + 1
SFFRNUM(2) = {P4}

DO FRNUM = {SFFRNUM(1)} {SFFRNUM(2)}
  SET/FORMAT I4
  IBDFNAME = "{P3}{FRNUM}.bdf"

  I = M$EXIST("{IBDFNAME}")
  IF I .NE. 1 THEN
    I = M$EXIST("{P3}{FRNUM}.fits")
    IF I .EQ. 1 IBDFNAME = "{P3}{FRNUM}.fits"
    I = M$EXIST("{P3}{FRNUM}.mt")
    IF I .EQ. 1 IBDFNAME = "{P3}{FRNUM}.mt"
    I = M$EXIST("{IBDFNAME}")
    IF I .NE. 1 THEN
      I = M$EXIST("/data/FEROS/raw/{P3}{FRNUM}.mt")
      IF I .EQ. 1 THEN
        $ ln -s /data/FEROS/raw/{P3}{FRNUM}.mt {P3}{FRNUM}.mt
        IBDFNAME = "{P3}{FRNUM}.mt"
      ENDIF
    ENDIF
  ENDIF

  I = M$EXIST("{IBDFNAME}")
  IF I .NE. 1 THEN
    WRITE/OUT "ERROR!!! Can NOT find file BDF, FITS or MT for {P3}{FRNUM}"
  ENDIF

  I = M$INDEX("{IBDFNAME}",".fits")
  IF I .GT. 0 THEN
    J = I+5
    OBDFNAME = "{IBDFNAME(1:{I})}bdf{IBDFNAME({J}:>)}"
  ENDIF
  I = M$INDEX("{IBDFNAME}",".mt")
  IF I .GT. 0 THEN
    J = I+3
    OBDFNAME = "{IBDFNAME(1:{I})}bdf{IBDFNAME({J}:>)}"
  ENDIF

  COPY/DK {IBDFNAME} INSTRUME/C/1/5 INSTR
  IF "{INSTR}" .EQ. "FEROS" THEN
    AREGION =  "501,411:700,610"
    BREGION =  "1101,411:1300,610"

    i = m$existd("{IBDFNAME}","ESO.DPR.CATG")
    if i .eq. 1 then
      write/out "{infile} seems to be a FIERA generated image..."
! So far only single Output modes are defined...
      COPY/DK {IBDFNAME} AMPLM/C/1/2 AMPLM
      if "{{IBDFNAME},ESO.DET.READ.CLOCK}" .eq.     "R 60Kps High Gai" then
        ROMODE = "60kHz,1,high"
        NUMAMPS = 1
      elseif "{{IBDFNAME},ESO.DET.READ.CLOCK}" .eq. "R 225Kps Low Gai" then
        ROMODE = "225kHz,1,low"
        NUMAMPS = 1
      elseif "{{IBDFNAME},ESO.DET.READ.CLOCK}" .eq. "R 625Kps Low Gai" then
        ROMODE = "625Hz,1,low"
        NUMAMPS = 1
      else
        write/out "WARNING!!! Readout mode not recognised..."
      endif
      EXDNS = "  "
      DO I = 1 NUMAMPS
        DIRNAME = "{ROMODE}"
        IF "{P7}" .NE. "DEF" DIRNAME = "{P7}"
        J = M$EXIST("{DIRNAME}")
        IF {J} .EQ. 0 $ mkdir -v {DIRNAME}
        REGION = "{AREGION}"
        IF "{P8}" .NE. "DEF" REGION = "{P8}"
        WRITE/OUT "{IBDFNAME}[{REGION}] --> {DIRNAME}/{OBDFNAME}"
        EXTRA/IMAG "{DIRNAME}/{OBDFNAME}" = "{IBDFNAME}" [{REGION}]
      ENDDO
    else
      write/out "{infile} seems to be a BIAS generated image..."
      COPY/DK {IBDFNAME} AMPLM/C/1/2 AMPLM
      COPY/DK {IBDFNAME} GAINM/C/1/4 GAINM
      IF "{AMPLM}" .EQ. "AB" THEN
        NUMAMPS = 2
        EXDNS = "AB"
      ENDIF
      IF "{P7}" .NE. "DEF" THEN
        NUMAMPS = 1
        EXDNS = "  "
      ENDIF
      DO I = 1 NUMAMPS
        DIRNAME = "{AMPLM({I}:{I})}{GAINM}"
        IF "{EXDNS}" .NE. "  " DIRNAME = "{AMPLM({I}:{I})}{EXDNS}{GAINM}"
        IF "{P7}" .NE. "DEF" DIRNAME = "{P7}"
        J = M$EXIST("{DIRNAME}")
        IF {J} .EQ. 0 $ mkdir -v {DIRNAME}
        REGION = "{{AMPLM({I}:{I})}REGION}"
        IF "{P8}" .NE. "DEF" REGION = "{P8}"
        WRITE/OUT "{IBDFNAME}[{REGION}] --> {DIRNAME}/{OBDFNAME}"
        EXTRA/IMAG "{DIRNAME}/{OBDFNAME}" = "{IBDFNAME}" [{REGION}]
      ENDDO
    endif
    
  ELSE
    WRITE/OUT "ERROR!!! Instrument NOT recognised."
    GOTO AORR
  ENDIF

ENDDO

DO I = 1 NUMAMPS
  IF "{AMPLM}" .NE. " " THEN
    DIRNAME = "{AMPLM({I}:{I})}{GAINM}"
    IF "{EXDNS}" .NE. "  " DIRNAME = "{AMPLM({I}:{I})}{EXDNS}{GAINM}"
    IF "{P7}" .NE. "DEF" DIRNAME = "{P7}"
    AGMODE = M$UPPER("{DIRNAME}")
    J = M$EXISTK("NUMTESTS") * M$EXISTK("CTAGMODE")
    IF J .EQ. 1 THEN
      J = NUMTESTS * 7 + 1
      K = J + 6
      CTAGMODE({J}:{K}) = "{AGMODE}"
      NUMTESTS = NUMTESTS + 1
    ENDIF
  ELSEIF "{ROMODE}" .NE. " " THEN
    DIRNAME = "{RDMODE}"
    IF "{P7}" .NE. "DEF" DIRNAME = "{P7}"
    AGMODE = "{DIRNAME}"
  ENDIF
  write/out "chan/dire {DIRNAME}"
  write/out "@@ ccd_standard_test {P1} {P2} {P3} {AGMODE} {P4} {P5} {P6}"
  write/out "chan/dire .."
  chan/dire {DIRNAME}
  @@ ccd_standard_test {P1} {P2} {P3} {AGMODE} {P4} {P5} {P6}
  chan/dire ..
ENDDO

AORR:
