! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: ferosResponse.prg,v 1.3 2005/10/17 12:13:27 jpritcha Exp $"
!==========================================================================
!
!    ferosResponse.prg
!    J.Pritchard, ESO-LS, 2005-08-30
!
!    Compute the response function from observation of SpecPhotStandard
!
!    Syntax:  @@ ferosResponse <fileNumber> [standard] [fibre]
!                              [Spectral flux directory]
!
!###########################################################################

def/par P1 ? I "Enter object frame number: "
def/par P2 ? I "       Standard star name: "
def/par P3 1 N "Fibre (1) : "
def/par P4 MIDASHOME:/calib/data/spec/ctio    CHAR "Spectral flux directory"

define/local i/i/1/1 0
define/local iord/i/1/1 0
define/local iordsf/i/1/2 0,0
define/local mord/i/1/1 0
define/local maxADU1/r/1/1 0.
define/local maxADU2/r/1/1 0.
define/local maxADUr/r/1/1 0.
define/local OFLABEL/C/1/100 " "
define/local mtfits/c/1/4    "mt"
define/local host/c/1/100   " "
define/local rim/c/1/100    " "
define/local catal/i/1/1   0

i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "fero{p1}.mt"
i = m$existd("fero{p1}.mt","ARCFILE")
if i .eq. 1 ARCFILE = "{fero{p1}.mt,ARCFILE}"
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif
OFLABEL = "response{P1}{P3}"
if "{ARCFILE}" .ne. "fero{p1}.mt" .and. "{UseAFDRSFITS}" .EQ. "Y" then
  mtfits = "fits"
  OFLABEL = "r.{ARCFILE(1:29)}.{P3}_res"
endif

if "{host}" .eq. "w2p2off" then
  $ xterm -iconic -fn 8x16 -display :0.1 -e kstart --desktop 3 --activate "xterm -geometry 1x1-0-0 -e sleep 1"
  assi/grap G,8
endif

set/cont long

rebin/line f{p1}{p3} f{p1}{p3}_reb 2.0
compute/air f{p1}{p3}_reb
extin/long f{p1}{p3}_reb f{p1}{p3}_reb_ext
set/long FLUXTAB = {P4}/{P2}
integr/long f{p1}{p3}_reb_ext.bdf resp=response{p1}{p3}.tbl

set/long FITYP = SPLINE
set/long PLOTYP = MAGNITUDE
response/long table=response{p1}{p3}.tbl image=response{p1}{p3}.bdf
stat/imag response{p1}{p3} [6000:6010]
comp/imag response{p1}{p3} = response{p1}{p3} / {outputr(3)}
host = m$symbol("HOST")
if "{host}" .eq. "w2p2off" then
  $ xterm -iconic -fn 8x16 -display :0.1 -e kstart --desktop 3 --activate "xterm -geometry 1x1-0-0 -e sleep 1"
  assi/grap G,8
endif
set/graph pmode=1 xaxis=auto yaxis=auto font=1
plot/axes 3000,9500 -0.1,2.55 ? "Wavelength [\AA]" "Response"
over/row response{p1}{p3}

outdisk/sfits response{p1}{p3}.bdf,response{p1}{p3}.tbl {OFLABEL}.{mtfits}

copy/grap postscript.l
$ mv postscript.ps {OFLABEL}.ps

if "{host}" .eq. "w2p2off" then
  crea/icat response.cat response*.bdf
  assi/grap G,9
  set/grap default
  set/graph pmode=1 xaxis=auto yaxis=auto font=1
  plot/axes 3000,9500 -0.1,2.55 ? "Wavelength [\AA]" "Response"
  set/grap colour=2 ltype=1
  next:
  store/frame rim response.cat 1 done
    over/row {rim}
  goto next
  done:
  set/grap colour=1 ltype=1 lwidth=3
  over/row response{p1}{p3}
  set/grap default
endif
