! "@(#) $Id: ferosSetRONandGAIN.prg,v 1.6 2005/12/16 00:23:11 jpritcha Exp $"
! @@ ferosSetRONandGAIN.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  ferosSetRONandGAIN.prg	  
! J.D.Pritchard, 2005-03-11
!
! PURPOSE
! Set the CCD_RON and CCD_GAIN for FEROS for any image
!
! USAGE
!
! @@ ferosSetRONandGAIN <file>
!
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 #           C "Enter filename : "
!
define/local i/i/1/1 0
define/local j/i/1/1 0
define/local xbin/i/1/1
define/local ybin/i/1/1
define/local iBinSupd/i/1/1 1
define/local romode/c/1/30 " "
!
! BIAS Gains (actually these are inverse gains...)
! LOW gain (ALOW, BLOW & ABLOW readout modes...)
define/local lgain/r/1/1 2.60
! HIGH gain (AHIGH, BHIGH & ABHIGH readout modes...)
define/local hgain/r/1/1 0.66
!
! FIERA Gains (actually these are inverse gains...)
!
! 60kHz,1,high,1x1
! Value taken from http://www.ls.eso.org/lasilla/sciops/2p2/CCDs/60/FIERA/LAMP5/60kHz,1,high/
! as at 2004-11-16: 1.031 +/- 0.007
define/local gain060high1x1/r/1/1 1.031
! as at 2004-11-16: 2.589 +/- 0.078
define/local ron060high1x1/r/1/1 2.589
!
! 60kHz,1,high,2x2
! Value taken from http://www.ls.eso.org/lasilla/sciops/2p2/CCDs/60/FIERA/LAMP5/60kHz,1,high/
! as at 2004-11-16: 1.031 +/- 0.007
define/local gain060high2x2/r/1/1 1.031
! as at 2004-11-16: 2.589 +/- 0.078
define/local ron060high2x2/r/1/1 2.589
!
! 225kHz,1,low,1x1
! Value taken from http://www.ls.eso.org/lasilla/sciops/2p2/CCDs/60/FIERA/LAMP5/225kHz,1,low/
! as at 2004-11-16: 2.962 +/- 0.018
define/local gain225low1x1/r/1/1 2.962
! as at 2004-11-16: 1.688 +/- 0.064
define/local ron225low1x1/r/1/1 1.688
! Previous value was 3.2, thus efficiency was being OVER estimated by 0.08%
! i.e. what was 20% should have been infact 18.5%
!
! 225kHz,1,low,2x2
! Value taken from http://www.ls.eso.org/lasilla/sciops/2p2/CCDs/60/FIERA/LAMP5/225kHz,1,low/
! as at 2004-11-16: 2.962 +/- 0.018
define/local gain225low2x2/r/1/1 2.962
! as at 2004-11-16: 1.688 +/- 0.064
define/local ron225low2x2/r/1/1 1.688
! Previous value was 3.2, thus efficiency was being OVER estimated by 0.08%
! i.e. what was 20% should have been infact 18.5%
!
! 625kHz,1x1,low
! Value taken from http://www.ls.eso.org/lasilla/sciops/2p2/CCDs/60/FIERA/LAMP5/625kHz,1,med/
! as at 2004-11-16: 2.554 +/- 0.015
define/local gain625med1x1/r/1/1 2.554
! as at 2004-11-16: 2.574 +/- 0.041
define/local ron625med1x1/r/1/1 2.574
!
set/format i1

i = m$existd("{p1}","ESO.DET.WIN1.BINX") * m$existd("{p1}","ESO.DET.WIN1.BINY")
if i .eq. 1 then
  xbin = {{p1},ESO.DET.WIN1.BINX}
  ybin = {{p1},ESO.DET.WIN1.BINY}
  if {xbin} .ne. 1 then
    write/out "ferosSetRONandGAIN: X-binning = {{p1},ESO.DET.WIN1.BINX} support experimental"
  endif
  if {ybin} .ne. 1 then
    write/out "ferosSetRONandGAIN: Y-binning = {{p1},ESO.DET.WIN1.BINX} support experimental"
  endif
  if xbin .ne. ybin then
    write/out "ferosSetRONandGAIN: Binning configuration not implemented. Can not continue."
    goto aorr
  endif
  if xbin .gt. 2 .or. ybin .gt. 2 then
    write/out "ferosSetRONandGAIN: Binning configuration not implemented. Can not continue."
    goto aorr
  endif
else
    iBinSupd = 0
    write/out "ferosSetRONandGAIN: Don't know how to determine Binning configuration."
    write/out "ferosSetRONandGAIN : Trying to continue anyway..."
endif

!
! Check first to see if the GAIN has been set manually...
i = m$existk("MYFEROSGAIN")
if i .eq. 1  then
  write/out "Setting GAIN by MYFEROSGAIN variable..."
  SET/FEROS CCD_GAIN={MYFEROSGAIN}
else
  i = m$existd("{P1}","ESO.DPR.CATG")
  if i .ne. 1 then
! Must be a BIAS image...
    write/out "{P1} seems to be a BIAS generated image..."
    if "{{P1},GAINM}" .eq. "LOW" then
      SET/FEROS CCD_GAIN={lgain}
    else
      SET/FEROS CCD_GAIN={hgain}
    endif
  else
! Must be a FIERA image...
    write/out "{P1} seems to be a FIERA generated image..."
    i = m$existk("FEROSROModeStr")
    j = m$existk("FEROSROModeCom")
    if iBinSupd .eq. 1 then
      romode = "{{P1},ESO.DET.READ.CLOCK}"
      if "{romode(1:16)}" .eq. "R 60Kps High Gai" then
        write/out "ReadOut Mode recognised as 60kHz,1,high,{xbin}x{ybin}"
        if i .eq. 1 FEROSROModeStr = "60kHz_1_high_{xbin}x{ybin}"
        if j .eq. 1 FEROSROModeCom = "60kHz,1,high,{xbin}x{ybin}"
        SET/FEROS CCD_GAIN={gain060high{xbin}x{ybin}}
        SET/FEROS CCD_RON={ron060high{xbin}x{ybin}}
      elseif "{romode(1:16)}" .eq. "R 225Kps Low Gai" then
        write/out "ReadOut Mode recognised as 225kHz,1,low,{xbin}x{ybin}"
        if i .eq. 1 FEROSROModeStr = "225kHz_1_low_{xbin}x{ybin}"
        if j .eq. 1 FEROSROModeCom = "225kHz,1,low,{xbin}x{ybin}"
        SET/FEROS CCD_GAIN={gain225low{xbin}x{ybin}}
        SET/FEROS CCD_RON={ron225low{xbin}x{ybin}}
      elseif "{romode(1:16)}" .eq. "R 625Kps Low Gai" then
        write/out "ReadOut Mode recognised as 625kHz,1,med,{xbin}x{ybin}"
        if i .eq. 1 FEROSROModeStr = "625kHz_1_med_{xbin}x{ybin}"
        if j .eq. 1 FEROSROModeCom = "625kHz,1,med,{xbin}x{ybin}"
        SET/FEROS CCD_GAIN={gain625med{xbin}x{ybin}}
        SET/FEROS CCD_RON={ron625med{xbin}x{ybin}}
      elseif "{romode(1:16)}" .eq. "R 625Kps Med Gai" then
        write/out "ReadOut Mode recognised as 625kHz,1,med,{xbin}x{ybin}"
        if i .eq. 1 FEROSROModeStr = "625kHz_1_med_{xbin}x{ybin}"
        if j .eq. 1 FEROSROModeCom = "625kHz,1,med,{xbin}x{ybin}"
        SET/FEROS CCD_GAIN={gain625med{xbin}x{ybin}}
        SET/FEROS CCD_RON={ron625med{xbin}x{ybin}}
      else
        write/out "WARNING!!! Readout mode not recognised, RON & GAIN unknown..."
        write/out "Setting both to a value of 1.00"
        SET/FEROS CCD_GAIN=1.00
        SET/FEROS CCD_RON=1.00
      endif
    else
      write/out "WARNING!!! Binning mode not recognised, RON & GAIN unknown..."
      write/out "Setting both to a value of 1.00"
      SET/FEROS CCD_GAIN=1.00
      SET/FEROS CCD_RON=1.00
    endif
  endif
endif

set/format

write/out "CCD_GAIN set to {CCD_GAIN}, CCD_RON set to {CCD_RON}"
