! "@(#) $Id: ferosTraceOrderInSingleFlat.prg,v 1.3 2005/08/15 05:37:57 jpritcha Exp $"
! @@ ferosTraceOrderInSingleFlat.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  ferosTraceOrderInSingleFlat.prg	  
! J.D.Pritchard, 2005-03-12
!
! PURPOSE
! Trace the orders in a single flat image...
!
! USAGE
!
! @@ ferosTraceOrderInSingleFlat <filePrefix> <fileNumber> [threshold=0.85] [y/N]
!
!        threshold : Search threshold, default value is 0.0, In this case 
!                    the GUESS session GORDER table is used.
!        [Y/N]     : Interactively adjust threshold (default = N)
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?  C "Enter fileprefix : "
define/par p2 ?  N "Enter filenumber : "
define/par p3 0.85        N "Threshold [0.85] : "
define/par p4 N           C "Interactive [y/N] : "
define/par p5 39          N "Expected Number of Orders (39) : "
define/par p6 Y           C "Subtract BIAS : "

define/local i/i/1/1 0 
define/local infile/c/1/60 {p1}{p2}.mt
define/local iaThresh/c/1/1   "{P4}"
define/local thresh/r/1/1     {p3}
define/local nthresh/r/1/1    {p3}
define/local expNO/i/1/1      {p5}
define/local NOloc/i/1/1      0

! GAIN and RON now set in separate MIDAS routine ferosSetRONandGAIN.prg
write/out 
@@ ferosSetRONandGAIN {infile}

! pre-reduction
!
i = m$exist("raw_image.bdf")
if i .eq. 1 $ rm -f raw_image.bdf
@@ prered {p2} raw_image {p6}
i = m$exist("raw_image.bdf")
if i .ne. 1 then
  write/out "ferosTraceOrderInSingleFlat.prg: Error!!! prered.prg failed (raw_image.bdf does not exist)"
  write/out "ferosTraceOrderInSingleFlat.prg: Can not continue for this file fero{num}.mt"
  goto exit
endif
save/feros tmp-f{p2}

set/feros RAW_IMG=raw_image

load/ima {RAW_IMG} sc=-4

! Trace the orders...
if thresh .eq. 0.0 then
! Use guess session...
  DEFINE/FEROS 
  load/tab {CENTER_TBL} :Fit_pos :Ypos ? 0 1  
else
! Search for the orders...
  searchFF:
  clear/channel overlay
  define/fero ? ? ? 10,25,5 {thresh} SR
  load/tab {CENTER_TBL} :Fit_pos :Ypos ? 0 1  
  copy/dk {CENTER_TBL}.tbl ECHORD/I/1/1 NOloc
  if "{iaThresh}" .EQ. "N" .and. NOloc .NE. expNO then
    write/out "{NOloc} NOT {expNO} orders located"
    inquire/key iaThresh "Do you wish to adjust the threshold interactively? (y/N) : " flush
  endif
!
! Interactively adjust Threshold (if chosen in command line options...)
  if "{iaThresh}" .NE. "N" then
    nthresh = thresh
    write/out "Press enter to continue or give a new threshold to search again."
    inquire/key nthresh "Current Threshold is {nthresh} : " flush
    write/out "{nthresh}"
    if nthresh .NE. thresh then
      thresh = nthresh
      goto searchFF
    endif
  endif
! Orders should now be defined... at least 39 of them...
!
endif

!! Save the parameters...
save/feros f{p2}
!! Remove the irrelvant saved files...
!$ rm -f f{p2}_WLC1.tbl f{p2}_WLC2.tbl f{p2}_TEMPLATE.bdf f{p2}_.tbl
!$ rm -f f{p2}_LINE1.tbl f{p2}_LINE2.tbl f{p2}_GORDER.tbl

!! Restore the Session parameters and cleanup...
init/feros tmp-f{p2}
$ rm -f tmp-f{p2}_*

exit:
