! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: fextRatios.prg,v 1.6 2005/10/27 13:21:36 jpritcha Exp $"
!==========================================================================
!
!    fextRatios.prg
!    J.Pritchard, ESO-LS, 2004-06-22
!
!    Compute and display image ratios
!
!    Syntax:  @@ fextRatios <RefImNum> <StartNum> [EndNum]
!                            [StartOrder,EndOrder] [Fiber] [MakePSfiles]
!                            [Landscape/Portrait]
!
!###########################################################################

define/par p1 ?     N "Reference image number : "
define/par p2 ?     N "Start number : "
define/par p3 {P2}  N "Finish number : "
define/par p4 50,50 C "Order range : "
define/par p5 1     C "Fibre (1/2) : "
define/par p6 N     C "Make PS files : "
define/par p7 l     C "Landscape/Portrait (l/p) : "

define/local i/i/1/1    0
define/local j/i/1/1    0
define/local iref/i/1/1 {p1}
define/local isf/i/1/2  {p2},{p3}
define/local mord/i/1/1 0
define/local osf/i/1/2  {p4}
define/local yaxsf/r/1/2 0.9,1.1
define/local ytick/r/1/1 0.
define/local fib/c/1/1   "{P5}"

define/local mms/r/1/39 0. All
define/local mmf/r/1/39 0. All

mms(01) = -10.0 ; mmf(01) =  5.0
mms(02) = -16.0 ; mmf(02) = 21.0
mms(03) = -18.0 ; mmf(03) = 30.5
mms(04) = -18.0 ; mmf(04) = 30.5
mms(05) = -20.0 ; mmf(05) = 30.5
mms(06) = -22.0 ; mmf(06) = 30.5
mms(07) = -22.0 ; mmf(07) = 30.5
mms(08) = -23.0 ; mmf(08) = 30.5
mms(09) = -23.0 ; mmf(09) = 30.5
mms(10) = -23.0 ; mmf(10) = 30.5
mms(11) = -23.0 ; mmf(11) = 30.5
mms(12) = -23.0 ; mmf(12) = 30.5
mms(13) = -24.0 ; mmf(13) = 30.5
mms(14) = -24.0 ; mmf(14) = 30.5
mms(15) = -24.0 ; mmf(15) = 30.5
mms(16) = -24.0 ; mmf(16) = 30.5
mms(17) = -24.0 ; mmf(17) = 30.5
mms(18) = -25.0 ; mmf(18) = 30.5
mms(19) = -25.0 ; mmf(19) = 30.5
mms(20) = -26.0 ; mmf(20) = 30.5
mms(21) = -27.0 ; mmf(21) = 30.5
mms(22) = -29.0 ; mmf(22) = 30.5
mms(23) = -30.5 ; mmf(23) = 30.5
mms(24) = -30.5 ; mmf(24) = 30.5
mms(25) = -30.5 ; mmf(25) = 30.5
mms(26) = -30.5 ; mmf(26) = 30.5
mms(27) = -30.5 ; mmf(27) = 30.5
mms(28) = -30.5 ; mmf(28) = 30.5
mms(29) = -30.5 ; mmf(29) = 30.5
mms(30) = -30.5 ; mmf(30) = 30.5
mms(31) = -30.5 ; mmf(31) = 30.5
mms(32) = -30.5 ; mmf(32) = 30.5
mms(33) = -30.5 ; mmf(33) = 30.5
mms(34) = -30.5 ; mmf(34) = 30.5
mms(35) = -30.5 ; mmf(35) = 30.5
mms(36) = -30.5 ; mmf(36) = 30.5
mms(37) = -30.5 ; mmf(37) = 30.5
mms(38) = -30.5 ; mmf(38) = 30.5
mms(39) = -30.5 ; mmf(39) = 30.5

define/local OFLABEL/C/1/100 " "

set/format i4

i = m$existk("refARCFILE")
if i .eq. 0 DEFINE/LOCAL refARCFILE/C/1/100 " " ? +lower_levels
refARCFILE = "fero{p1}.mt"
i = m$existd("fero{p1}.mt","ARCFILE")
if i .eq. 1 refARCFILE = "{fero{p1}.mt,ARCFILE}"
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif

do i = {isf(1)} {isf(2)}
  j = m$existk("ARCFILE")
  if j .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
  ARCFILE = "fero{i}.mt"
  j = m$existd("fero{i}.mt","ARCFILE")
  if j .eq. 1 ARCFILE = "{fero{i}.mt,ARCFILE}"
  OFLABEL = "f{i}o{iref}ext{fib}-{p4}"
  if "{ARCFILE}" .ne. "fero{i}.mt" .and. "{UseAFDRSFITS}" .EQ. "Y" OFLABEL = "r.{ARCFILE(1:29)}o{refARCFILE(7:29)}.{fib}-{p4}_extRat"

  yaxsf(1) = 0.92
  yaxsf(2) = 1.1 + ( osf(2) - osf(1) ) * 0.16
  ytick = 2 * (yaxsf(2) - yaxsf(1))
  set/grap default
  set/grap pmode=1 font=1 yformat=NONE
!  set/grap xax=0,4103 yax={yaxsf(1)},{yaxsf(2)}
  plot/axes -31,31,5,0.5 {yaxsf(1)},{yaxsf(2)},{ytick},{ytick} ? "Pixel [mm]" "Relative Flux"
  label/grap "f{i}ext{fib} / f{iref}ext{fib}" 0.5,0.975,no ? 1.0 0
  do mord = {osf(1)} {osf(2)}
    if mord .ge. ORDER_FIRST .and. mord .le. ORDER_LAST then
      j = ORDER_LAST - mord + 1
      set/format i4
      write/out "Computing f{i}o{iref}ext{fib}..."
      comp/imag f{i}o{iref}ext{fib}  = f{i}ext{fib} / f{iref}ext{fib}
      @@ ferosSetGrapYax {yaxsf(1)} {yaxsf(2)}
      set/grap colour=1
      if mord .ne. osf(2) over/line 1 -31,1.08,wo 31,1.08,wo
      over/line 2 -31,1.00,wo 31,1.00,wo
      set/grap colour=4
      overplot/row f{i}o{iref}ext{fib} @{j} {mms({j})},{mmf({j})}
      set/grap colour=1
      set/format i1
      label/grap "0.95" -31.5,0.95,wo ? 0.20 2
      over/line 1 -31,0.95 -30.5,0.95
      over/line 1  31,0.95  30.5,0.95
      label/grap "1.00" -31.5,1.00,wo ? 0.30 2
      over/line 1 -31,1.00 -30.0,1.00
      over/line 1  31,1.00  30.0,1.00
      label/grap "1.05" -31.5,1.05,wo ? 0.20 2
      over/line 1 -31,1.05 -30.5,1.05
      over/line 1  31,1.05  30.5,1.05
      label/grap "{mord}"  31.5,1.0,wo ? 0.55 1
      set/format i4
    else
      write/out "Error!!! Order {j} [m={mord}] not between ORDER_FIRST({ORDER_FIRST}) and ORDER_LAST({ORDER_LAST})"
    endif
    yaxsf(1)  = yaxsf(1) - 0.16
    yaxsf(2)  = yaxsf(2) - 0.16
  enddo
  if "{P6}" .eq. "Y" then
    copy/grap postscript.{p7}
    $ mv postscript.ps {OFLABEL}.ps
  endif
enddo
