! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: fextRatios_cat.prg,v 1.3 2004/11/21 20:15:19 jpritcha Exp $"
!==========================================================================
!
!    fextRatios_cat.prg
!    J.Pritchard, ESO-LS, 2004-06-22
!
!    Compute and display image ratios from a catalogue
!
!    Syntax:  @@ fextRatios_cat <Catalogue> [RefImNum]
!                                [StartOrder,EndOrder] [Fiber] [MakePSfiles]
!                                [Landscape/Portrait]
!
!###########################################################################

def/par P1 FF.cat                         CHAR "Catalogue filename : "
def/par P2 0                              N    "Reference Image : "
define/par p3 25,25 C "Order range : "
define/par p4 1     C "Fibre (1/2) : "
define/par p5 N     C "Make PS files : "
define/par p6 l     C "Landscape/Portrait (l/p) : "

DEFINE/LOCAL CATAL/I/1/1   0
define/local infile/c/1/60 " " all
define/local refIm/c/1/4   "    "
define/local ici/i/1/1 0

!! The following handles the case that P2 is the number of some image...
set/format
set/format i4
refIm = "{P2}"
set/format

!! If P2=0, use the last image of the catalogue as the reference
if {P2} .eq. 0 then
  defref_loop:
  store/frame infile {p1} 1 findrl
    set/format
    set/format i4
    refIm = "{infile(5:8)}"
    set/format
  goto defref_loop
  findrl:
endif

!! If P2<0, use image number -1*P2 of the catalogue as the reference
if {P2} .lt. 0 then
  ici = -1 * {p2}
  ref_loop:
  store/frame infile {p1} 1 finrl

    if catal .le. ici then
      set/format
      set/format i4
      refIm = "{infile(5:8)}"
      set/format
    endif

  goto ref_loop
  finrl:
endif

catal = 0
next:
store/frame infile {p1} 1 done

  if refIm .ne. infile(5:8) then
    @@ fextRatios {refIm} {infile(5:8)} ? {p3} {p4} {p5} {p6}
  endif

goto next

done:

exit:
