! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: fiberratio.prg,v 1.9 2005/10/17 12:13:27 jpritcha Exp $"
!==========================================================================
!
!    fiberratio.prg
!    A. Kaufer, ESO, 23-Jan-1999
!
!    Compute relative fiber efficiency
!
!    Syntax:  @@ fiberratio [filenum]
!
!    with 
!     filenum : the 4-digit number of the spectrum of the sky spectrum, 

!###########################################################################

def/par P1 ? I "Enter number of sky spectrum frame: "
!
define/local num/i/1/1 {p1}
define/local i/i/1/1 0
define/local win/i/1/3 0 all
define/local rebstep/r/1/2 0,0
define/local mergemtd/c/1/20 " " all
define/local OFLABEL/C/1/100 " "
define/local mtfits/c/1/4    "mt"
define/local host/c/1/100   " "

i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "fero{p1}.mt"
i = m$existd("fero{p1}.mt","ARCFILE")
if i .eq. 1 ARCFILE = "{fero{p1}.mt,ARCFILE}"
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif
OFLABEL = "fiberratio{P1}"
if "{ARCFILE}" .ne. "fero{p1}.mt" .and. "{UseAFDRSFITS}" .EQ. "Y" then
  mtfits = "fits"
  !! Relative Fibre Response...
  OFLABEL = "r.{ARCFILE(1:29)}_rfr"
endif
!
!
! pre-reduction
!
i = m$exist("raw_image.bdf")
if i .eq. 1 $ rm -f raw_image.bdf
@@ prered {num} raw_image
i = m$exist("raw_image.bdf")
if i .ne. 1 then
  write/out "autoreduce.prg: Error!!! prered.prg failed (raw_image.bdf does not exist)"
  write/out "autoreduce.prg: Can not continue for this file fero{num}.mt"
  goto exit
endif
!
! reduction starts here
!
BACKGR/FEROS raw_image back
RECTIFY/FEROS back back_str
EXTRACT/FEROS back_str b{num}ext {SPECTR_TYPE}S{PROFILE_GET}{IMG_WRITE}
rebstep(1) = {REBIN_STEP}
rebstep(2) = 0
REBIN/FERO b{num}ext {LINE_POS_TBL} rebinned I {rebstep(1)},{rebstep(2)}

mergemtd = "{MERGE_MTD}"
MERGE/FERO rebinned fib 1,39 NOAPP
SET/FEROS MERGE_MTD={mergemtd}

crea/tab fiberratio{num} 3 50 
crea/col fiberratio{num} :order I*2
crea/col fiberratio{num} :lamc  R*4
crea/col fiberratio{num} :ratio R*4

do i = 1 39
 comp/ima ratio{i} = fib1{i}/fib2{i}
 win(1) = {ratio{i},NPIX(1)}/2
 win(2) = win(1)-500
 win(3) = win(1)+500
 stat/ima ratio{i}[@{win(2)}:@{win(3)}]
 fiberratio{num},:order,{i} = i
 fiberratio{num},:lamc,{i} = win(1)*{ratio{i},STEP(1)}+{ratio{i},START(1)} 
 fiberratio{num},:ratio,{i} = outputr(8)
enddo

outdisk/fits fiberratio{num}.tbl fiberratio{OFLABEL}.{mtfits}

write/out "-------------------------------------------------------------------"
write/out "Computed ratio of fiber efficiency (fiber 1/fiber 2) stored in     "
write/out "table fiberratio{p1}"
write/out "Use columns :lamc :ratio"
write/out "-------------------------------------------------------------------"
!
host = m$symbol("HOST")
if "{host}" .eq. "w2p2off" then
  $ xterm -iconic -fn 8x16 -display :0.1 -e kstart --desktop 3 --activate "xterm -geometry 1x1-0-0 -e sleep 1"
  assi/grap G,5
endif
plo/ax 3500,9300 0.0,2.0  ? "Wavelength [\AA ]" "Fiber Efficiency Ratio"
over/tab fiberratio{num} :lamc :ratio 2
label/gra "FEROS fiber efficiency test (input files: fero{p1}.mt)" 3500,2.03 0 1 1
set/gra xa ya
copy/grap postscript
$ mv postscript.ps {OFLABEL}.ps

exit:
