! %W% (ESO-IPG) %G% %U%
! "@(#) $Id: focus.prg,v 1.7 2005/11/21 21:25:26 jpritcha Exp $"
! @@ focus.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  focus.prg	  
! O.Stahl, A.Kaufer	981105
!
! PURPOSE
! measure calibration lines with gauss-hermite polynomials
! to check FEROS image-quality/focus
!
! USAGE
!
! @@ focus filenumber
!
! with :    filenumber 	:  running 4-digit filenumber
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/para p1 ? C "Enter Thorium-Argon frame number: "
define/par p2 N     C "Make PS files : "
define/par p3 l     C "Landscape/Portrait (l/p) : "
!
define/local fn/i/1/1 0
define/local fib/c/1/20 " " all
define/local i/i/1/1 0
define/local step/d/1/2     0.015,0.015
define/local size/i/1/2     2148,4102
define/local xbin/i/1/1     1
define/local ybin/i/1/1     1
!
i = m$existd("fero{p1}.mt","ESO.DET.WIN1.BINX") * m$existd("fero{p1}.mt","ESO.DET.WIN1.BINY")
if i .eq. 1 then
  xbin = {fero{p1}.mt,ESO.DET.WIN1.BINX}
  ybin = {fero{p1}.mt,ESO.DET.WIN1.BINY}
  step(1) = step(1) * xbin
  size(1) = size(1) / xbin
  step(2) = step(2) * ybin
  size(2) = size(2) / ybin
endif

!goto start 
i = m$exist("raw_image.bdf")
if i .eq. 1 $ rm -f raw_image.bdf
@@ prered {p1} raw_image
i = m$exist("raw_image.bdf")
if i .ne. 1 then
  write/out "autoreduce.prg: Error!!! prered.prg failed (raw_image.bdf does not exist)"
  write/out "autoreduce.prg: Can not continue for this file fero{p1}.mt"
  goto end
endif

BACK/FEROS raw_image back
RECTIFY/FEROS back back_str
EXTRACT/FEROS back_str b{p1}ext GSNN
!
SEARCH/FERO b{p1}ext 5,10000,1 b{p1}lines
CALIBRATE/FEROS b{p1}lines ? ? ? ? c
crea/gra 0
set/gra ya=-0.05,0.05
plot/tab b{p1}lines1 :mabs :residual
set/gra ya

!start: 
crea/gra 9 600,600
set/gra color=1

set/format I1
do fn = 1 2 
 set/gra color=1
 if {fn} .eq. 1 then
  plot/ax 0,{size(2)} 0,8 -65,-56,15,10 "x-axis [pixels]" "FWHM_x [pixels]" 
  fib = "object"
 else
  over/ax 0,{size(2)} 0,8 -65,-56,15,73 " "              "FWHM_x [pixels]" 
  fib = "sky"
  label/gra "FEROS focus test (input file: fero{p1}.mt)" 0,8.5 0 1.5 1
 endif
 label/gra "Fiber {fn} ({fib})" 100,7 0 1.5 1
 over/line 1 0,2.2 {size(2)},2.2 
 over/line 2 0,2.53 {size(2)},2.53 
 over/line 2 0,1.7 {size(2)},1.7

 sele/tab b{p1}lines{fn} :wave.NE.NULL.and.abs(:residual).lt.0.02
!sele/tab b{p1}lines{fn} :peak.gt.20000
 if outputi(1) .gt. 0 then
   copy/tab b{p1}lines{fn} &lines{fn}
   comp/tab &lines{fn} :x = (:x+30.72)/{step(1)}

   copy/ii b{p1}ext{fn} &ext
   write/descr &ext START/D/1/2 1,1
   write/descr &ext STEP/D/1/2 1,1

   IMAQUA/FERO &ext &lines{fn}.tbl 8 4

   comp/tab &lines{fn} :GH1m = :GH1-1.
   sele/tab &lines{fn} abs(:GH2).lt.0.05.and.abs(:GH1m).lt.0.05

   copy/tab &lines{fn} &liness{fn}

   sele/tab &liness{fn} :y.ge.22 
 ! .and.:peak.lt.70000 
   set/gra color=2
   if outputi(1) .gt. 0 then
     stat/tab &liness{fn} :GFWHM
     over/tab &liness{fn} :x :GFWHM 4
   endif

   sele/tab &liness{fn} :y.gt.8.and.:y.lt.22 
 ! .and.:peak.lt.70000 
   set/gra color=3
   if outputi(1) .gt. 0 then
     stat/tab &liness{fn} :GFWHM
     over/tab &liness{fn} :x :GFWHM 3
   endif

   sele/tab &liness{fn} :y.le.8 
 ! .and.:peak.lt.70000
   set/gra color=4
   if outputi(1) .gt. 0 then
     stat/tab &liness{fn} :GFWHM
     over/tab &liness{fn} :x :GFWHM 2
   endif

   set/gra color=1
   sele/tab &liness{fn} all
 endif

enddo
set/gra xa ya color 
!
if "{P2}" .eq. "Y" then
  copy/grap postscript.{p3}
  $ mv postscript.ps f{p1}-focus.ps
endif

end:
