! "@(#) $Id: getguess.prg,v 1.6 2005/11/11 17:26:48 jpritcha Exp $"
! @@ getarchive.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  getguess.prg
! P. Francois	990621
!
! PURPOSE
! Restores a guess session from a tar.gz 
!
! USAGE
!
! @@ getguess <NNNN> [tar filespec] [ThAr prefix] [Check]
!
! with : NNNN           :  Number of the guess session to be saved
!        tar filespec   :  guess session tarfile
!                          by default = guess<number>.tar.gz
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?           N "Enter guess number : "
define/par p2 null        C "Tar file name : "
define/par p3 ThAr        CHAR "ThAr prefix (ThAr) : "
define/par p4 N           CHAR "Check if already exists (Y|n) : "

define/local tarfile/c/1/200 "guess{p1}.tar.gz"
define/local i/i/1/1 0

if "{P2}" .ne. "null" tarfile = "{p2}"

if "{P4}" .eq. "Y" then
  i = m$exist("{p3}{p1}_INIT.tbl")
  if i .eq. 1 goto setgsess
endif

WRITE/OUT
WRITE/OUT "          Reading tar file"
WRITE/OUT 
$ eval "gzip -dc {tarfile} | tar xvf -"

WRITE/OUT
WRITE/OUT "          Converting FITS files to bdf files" 
WRITE/OUT 
indisk/fits {p3}{p1}_INIT.mt  {p3}{p1}_INIT.tbl
indisk/fits {p3}{p1}_GORDER.mt  {p3}{p1}_GORDER.tbl
indisk/fits {p3}{p1}_LINE1.mt  {p3}{p1}_LINE1.tbl
indisk/fits {p3}{p1}_LINE2.mt  {p3}{p1}_LINE2.tbl
indisk/fits {p3}{p1}_ORDER.mt  {p3}{p1}_ORDER.tbl
indisk/fits {p3}{p1}_TEMPLATE.mt  {p3}{p1}_TEMPLATE.bdf
indisk/fits {p3}{p1}_WLC1.mt  {p3}{p1}_WLC1.tbl
indisk/fits {p3}{p1}_WLC2.mt  {p3}{p1}_WLC2.tbl
indisk/fits ThAr50000.mt ThAr50000.tbl
indisk/fits BLAZE.mt BLAZE.tbl
$\rm {p3}{p1}_*.mt ThAr50000.mt BLAZE.mt

setgsess:
i = m$existk("gsess")
if i .eq. 1 gsess = "{p3}{p1}"

exit:
