! "@(#) $Id: getsession.prg,v 1.6 2005/11/11 17:26:48 jpritcha Exp $"
! @@ getsession.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  getsession.prg
! P. Francois	990614
!
! PURPOSE
! Restores a complete session from a tar 
! Can be used directly with INIT/FEROS 
!
! USAGE
!
! @@ getsession <NNNN> <MMMM> [tar filespec] [FF prefix] [ThAr prefix] [Check]
!
! with : number  :  Number of the session to be restored
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?           N "Enter number of associated mean ThAr : "
define/par p2 ?           N "  Enter number of associated mean FF : "
define/par p3 null        C "Tar file name : "
define/par p4 FF          CHAR "FF prefix (FF) : "
define/par p5 ThAr        CHAR "ThAr prefix (ThAr) : "
define/par p6 N           CHAR "Check if already exists (Y|n) : "

define/local tarfile/c/1/200 "session{p1}_{p2}.tar.gz"
define/local i/i/1/1         0

if "{P3}" .ne. "null" tarfile = "{p3}"

if "{P6}" .eq. "Y" then
  i = m$exist("{p5}{p1}_INIT.tbl")
  if i .eq. 1 goto setgsess
endif

WRITE/OUT 
WRITE/OUT " Extracting tar file"
WRITE/OUT 
$ eval "gzip -dc {tarfile} | tar xvf -"

WRITE/OUT
WRITE/OUT " Converting FITS files to bdf files" 
WRITE/OUT 
indisk/fits {p5}{p1}_INIT.mt     {p5}{p1}_INIT.tbl
indisk/fits {p5}{p1}_GORDER.mt   {p5}{p1}_GORDER.tbl
indisk/fits {p5}{p1}_LINE1.mt    {p5}{p1}_LINE1.tbl
indisk/fits {p5}{p1}_LINE2.mt    {p5}{p1}_LINE2.tbl
indisk/fits {p5}{p1}_ORDER.mt    {p5}{p1}_ORDER.tbl
indisk/fits {p5}{p1}_TEMPLATE.mt {p5}{p1}_TEMPLATE.bdf
indisk/fits {p5}{p1}_WLC1.mt     {p5}{p1}_WLC1.tbl
indisk/fits {p5}{p1}_WLC2.mt     {p5}{p1}_WLC2.tbl
indisk/fits {p5}{p1}.mt          {p5}{p1}.bdf
indisk/fits ThAr50000.mt ThAr50000.tbl
indisk/fits BLAZE.mt BLAZE.tbl
indisk/fits {p4}{p2}*.mt 
restore/name toto0001.bdf
restore/name toto0002.bdf
restore/name toto0003.bdf
indisk/fits cop_coeffs1.mt cop_coeffs1.tbl
indisk/fits cop_coeffs2.mt cop_coeffs2.tbl
$\rm {p5}{p1}.mt {p5}{p1}_*.mt ThAr50000.mt BLAZE.mt
$\rm {p4}{p2}*.mt cop_coeffs1.mt cop_coeffs2.mt

setgsess:
i = m$existk("gsess")
if i .eq. 1 gsess = "{p5}{p1}"

exit:
