! @(#)init.prg	15.1.1.1 (ESO-IPG) 01/12/01 17:34:18
! "@(#) $Id: init.prg,v 1.31 2006/02/02 11:46:25 jpritcha Exp $"
! @@ init.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  init.prg	  
! O.Stahl, A.Kaufer	981105
! J.D.Pritchard, 2004-09-08
!
! PURPOSE
! initialize catalogues for FF, ThAr, and Objects
! average all available FFs and ThArs
! reduce averaged FF, ThAr as guess for auto reduction
!
! USAGE
!
! @@ init <guess> <action> [threshold=0.0] [y/N] [Order] [FF.cat] [ThAr.cat] [Expected Number of Orders]
!
! with : guess     :  Name of guess session to be used
!        action    :  Action to be taken:
!		   	start   :  full procedure from start
!			flat    :  start with reduction of flat
!			calib	:  start with reduction of calibration	
!                       plots   :  Make the plots
!			reset	:  reset catalogues 
!        threshold : Search threshold, default value is 0.0, In this case 
!                    the GUESS session GORDER table is used.
!        [Y/N]     : Interactively adjust threshold (default = N)
!        [x.x,y.y] : Threshold AutoSearch Range
!        [FF.cat]  : Image catalogue with flatfields, default FF.cat
!       [ThAr.cat] : Image catalogue with Wavelength calibrations, default ThAr.cat
![Expected Number of Orders] : When using the search method for order location
!                              specify the number of orders expected to be
!                              found, default 39
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 #           C "Enter name of guess session : "
define/par p2 start       C "Enter action: [start/flat/calib/reset] : "
define/par p3 0.0         N "Threshold [0.0] : "
define/par p4 N           C "Interactive [y/N] : "
define/par p5 0.0,0.0     C "Threshold AutoSearch Range : "
define/par p6 FF.cat      C "FlatField image catalogue (FF.cat) : "
define/par p7 ThAr.cat    C "WaveLength Calibration image catalogue (ThAr.cat) : "
define/par p8 39          N "Expected Number of Orders (39) : "
!
!
define/local tmpname/c/1/40 " " all
define/local infile/c/1/40 " "  all
define/local catal/i/1/1        0 
define/local ind/i/1/1          0
define/local i/i/1/1            0
define/local mm/i/1/1           0
define/local action/c/1/40      {p2}
define/local expNO/i/1/1        {p8}
!
define/local iaThresh/c/1/1    "{P4}"
define/local thresh/r/1/1       {p3}
define/local nthresh/r/1/1      {p3}
define/local GTR/r/1/2          {p5}
define/local TS/r/1/1           0.01
define/local minTS/r/1/1        0.001
define/local p1str/c/1/20      "{p1}"
define/local ymax/r/1/1         0.
define/local iOtoPlot/i/1/1     20
!
define/local FEROSROModeStr/c/1/30    "undef" ? +lower_levels
!
define/local OFLABEL/C/1/100 " "
!
i = m$existk("ARCFILE")
if i .eq. 0 DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
ARCFILE = "{WLC_IMG}"
i = m$existd("{WLC_IMG}","ARCFILE")
if i .eq. 1 ARCFILE = "{{WLC_IMG},ARCFILE}"
!! Output FITS & PS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif
OFLABEL = "{WLC_IMG}"
if "{ARCFILE}" .ne. "{WLC_IMG}" .and. "{UseAFDRSFITS}" .EQ. "Y" OFLABEL = "{ARCFILE(1:29)}"
!
set/grap pmode=1 font=1
!
! GAIN and RON now set in separate MIDAS routine ferosSetRONandGAIN.prg
!
! jump according to required action
!
goto {action}

reset:
if "{p1}" .eq. "#" then
 INIT/FEROS
 write/out "Default session parameters loaded"
 p1str = "Default"
else
 INIT/FEROS  {p1}
 write/out "Session parameters loaded from session {p1}"
endif

write/out "Resetting catalogues for Flats, ThArs, Darks, and Objects" 
!crea/icat Feros null
crea/icat ThAr null
crea/icat ThArNe null
crea/icat FF null
crea/icat Bias null
crea/icat Dark null
crea/icat Objects null
crea/icat sol null

goto exit

start:
!
! set FEROS context 
! initialize session according to a saved guess session,
! 	i.e., typically the session from the last night
!
! Don't do this otherwise it overrides set/context feroshh
! set/context feros
if "{p1}" .eq. "#" then
 INIT/FEROS
 write/out "Default session parameters loaded"
 p1str = "Default"
else
 INIT/FEROS  {p1}
 write/out "Session parameters loaded from session {p1}"
endif

!
! average flatfield expsoures, 
! averaged flat is used for further reductions
!
@@ average_cat {p6}

! average calibration exposures, 
! averaged thar is used for wavelength calibration
!
@@ average_cat {p7}

flat:
! reduce FF: 	order definition
!		background subtraction
!		order straightening
!		order extraction		
!
load/ima {RAW_IMG} sc=-4
!
! set gain acc. to descriptor 
! GAIN and RON now set in separate MIDAS routine ferosSetRONandGAIN.prg
write/out 
@@ ferosSetRONandGAIN {RAW_IMG}
!
!! To enable the following feature, in MIDAS type:
!! write/key TrimFF4Search/c/1/20 "@2,<:>,>"
!! To remove the first column from the FF for searching...
i = m$existk("TrimFF4Search")
if i .eq. 1 then
  define/local saveFF/c/1/30
  saveFF = "{RAW_IMG}"
  write/out "Trimming {RAW_IMG} by [{TrimFF4Search}]"
  write/out "as per the TrimFF4Search MIDAS variable."
  extract/image {RAW_IMG}c = {RAW_IMG} [{TrimFF4Search}]
  set/feros RAW_IMG={RAW_IMG}c
endif
!
! Trace the orders...
if thresh .eq. 0.0 then
! Use guess session...
  clear/channel overlay
  define/feros
  load/tab {CENTER_TBL} :Fit_pos :Ypos ? 0 1  
else
! Search for the orders...
  searchFF:
  clear/channel overlay
  define/fero ? ? ? ? {thresh} SR
  load/tab {CENTER_TBL} :Fit_pos :Ypos ? 0 1
  noSearchFF:
  copy/dk {CENTER_TBL}.tbl ECHORD/I/1/1 NOloc
  if "{iaThresh}" .EQ. "N" .and. NOloc .NE. expNO then
    write/out "{NOloc} NOT {expNO} orders located"
    if {GTR(1)} .gt. 0. .and. {GTR(2)} .gt. {GTR(1)} then
      if {thresh} .gt. {GTR(1)} .and. {thresh} .lt. {GTR(2)} i = 1
      if {i} .eq. 1 .and. {TS} .gt. {minTS} then
        write/out "Trying to adjust the threshhold automatically..."
        if {NOloc} .gt. {expNO} then
          if {nthresh} .gt. {thresh} TS = TS / 2.
          thresh = thresh + TS
        else
          if {nthresh} .lt. {thresh} TS = TS / 2.
          thresh = thresh - TS
        endif
        if {TS} .gt. {minTS} goto searchFF
        goto noSearchFF
      else
        write/out "Could NOT get the expected number of orders using an automatic search for a good"
        write/out "threshold value..."
        i = m$existk("OBStart")
        if {i} .ne. 1 define/local OBStart/c/1/20 "{WLC_IMG}-{RAW_IMG}"
        $ ferosQCWarningOrError W "DRSInit-{OBStart}" init.prg "Automatic Threshold Search FAILED"
        inquire/key iaThresh "Do you wish to adjust the threshold interactively? (y/N) : " flush
      endif
    else
      inquire/key iaThresh "Do you wish to adjust the threshold interactively? (y/N) : " flush
    endif
  endif
!
! Interactively adjust Threshold (if chosen in command line options...)
  if "{iaThresh}" .NE. "N" then
    nthresh = thresh
    write/out "Press enter to continue or give a new threshold to search again."
    inquire/key nthresh "Current Threshold is {nthresh} : " flush
    write/out "{nthresh}"
    if nthresh .NE. thresh then
      thresh = nthresh
      goto searchFF
    endif
  endif
! Orders should now be defined... at least 39 of them...
  copy/dk {CENTER_TBL}.tbl ECHORD/I/1/1 NOloc
  if NOloc .ne. expNO then
    write/out "Can NOT find the expected number orders."
    write/out "Can NOT proceed."
    i = m$existk("OBStart")
    if {i} .ne. 1 define/local OBStart/c/1/20 "{WLC_IMG}-{RAW_IMG}"
    $ ferosQCWarningOrError E "DRSInit-{OBStart}" init.prg "Order Search FAILED to find the expected number of orders."
    goto exit
  endif
!
endif
i = m$existk("saveFF")
if i .eq. 1 set/feros RAW_IMG={saveFF}

BACKGR/FEROS {RAW_IMG} back
RECTIFY/FEROS back back_str
! prepare cross-order profiles for optimum extraction
EXTRACT/FEROS back_str {RAW_IMG}ext GOYN
! extract flat with standard extraction
EXTRACT/FEROS back_str {RAW_IMG}ext GSNN
SET/FEROS FLAT_IMG={RAW_IMG}ext

clear/channel over


calib:
!reduce ThAr	background subtraction
!		order straightening
!		order extraction		
!		line search
!		wavelength calibration
!
load/ima {WLC_IMG} sc=-4
BACKGR/FEROS {WLC_IMG} back
RECTIFY/FEROS back back_str
EXTRACT/FEROS back_str {WLC_IMG}ext GS

SET/FEROS LINE_POS_TBL={WLC_IMG}lines
SEARCH/FERO {WLC_IMG}ext {LINE_W},{LINE_THRES},1 {LINE_POS_TBL}
CALIBRATE/FEROS {LINE_POS_TBL} ? ? ? ? {INIT_WLC}

!!! Make 1-Dim FF and ThAr images...
REBIN/FERO {RAW_IMG}ext {LINE_POS_TBL} rebinned I {REBIN_STEP},0.0 ? OS
MERGE/FERO rebinned f{RAW_IMG}

FLAT/FERO {WLC_IMG}ext {FLAT_IMG} f{WLC_IMG}ext
REBIN/FERO f{WLC_IMG}ext {LINE_POS_TBL} rebinned I {REBIN_STEP},0.0 ? OS
MERGE/FERO rebinned f{WLC_IMG}

if "{FEROSROModeStr}" .ne. "undef" then
  $ echo "init/feros {WLC_IMG}" >Init-{FEROSROModeStr}.prg
  if "{FEROSROModeStr}" .eq. "225kHz_1_low_1x1" $ ln -fs Init-{FEROSROModeStr}.prg Init-DEFAULT.prg
  if "{FEROSROModeStr}" .eq. "225kHz_1_low_1x1" $ ln -fs Init-{FEROSROModeStr}.prg Init-DEFAULT_1x1.prg
  if "{FEROSROModeStr}" .eq. "225kHz_1_low_2x2" $ ln -fs Init-{FEROSROModeStr}.prg Init-DEFAULT_2x2.prg
endif

COPY/II         {TEMPLT_IMG} {RAW_IMG}_{TEMPLT_IMG}.bdf
!$ mv postscript.ps {OFLABEL}-{p1str}-rms-SKY.ps


plots:
assi/grap G,1
set/grap default
set/grap xa=23,65,5,1 ya=-0.05,0.05 font=1
sele/tab {LINE_POS_TBL}1 abs(:residual).lt.0.05
plot/tab {LINE_POS_TBL}1 :mabs :residual
set/grap colour=2
over/line 2 25,-0.05 25,0.05
set/grap colour=4
over/line 2 63,-0.05 63,0.05
set/grap colour=1
stat/tab {LINE_POS_TBL}1 :residual
label/graphic "OBJ Fib :: GUESS {p1str} :: rms={outputr(4)} \{\AA \} :: n={outputi(2)}" 0.16,0.90,no 0 1 1
copy/kd outputr/r/1/4 {LINE_POS_TBL}1.tbl rstats/r/1/4
copy/kd outputi/i/1/2 {LINE_POS_TBL}1.tbl istats/i/1/2
copy/graph postscript.l
$ mv postscript.ps {OFLABEL}-{p1str}-rms-OBJ.ps

assi/grap G,2
set/gra xa=23,65,5,1 ya=-0.05,0.05 font=1
sele/tab {LINE_POS_TBL}2 abs(:residual).lt.0.05
plot/tab {LINE_POS_TBL}2 :mabs :residual
set/grap colour=2
over/line 2 25,-0.05 25,0.05
set/grap colour=4
over/line 2 63,-0.05 63,0.05
set/grap colour=1
stat/tab {LINE_POS_TBL}2 :residual
label/graphic "SKY Fib :: GUESS {p1str} :: rms={outputr(4)} \{\AA \} :: n={outputi(2)}" 0.16,0.90,no 0 1 1
copy/kd outputr/r/1/4 {LINE_POS_TBL}2.tbl rstats/r/1/4
copy/kd outputi/i/1/2 {LINE_POS_TBL}2.tbl istats/i/1/2
copy/graph postscript.l
$ mv postscript.ps {OFLABEL}-{p1str}-rms-SKY.ps

set/grap xaxis=auto
!! check extracted order profiles in flat image...
stat/imag {RAW_IMG}ext1 [<,{iOtoPlot}:>,{iOtoPlot}]
ymax = outputr(2)
stat/imag {RAW_IMG}ext2 [<,{iOtoPlot}:>,{iOtoPlot}]
if ymax .lt. outputr(2) ymax = outputr(2)
ymax = ymax * 1.05
assi/grap G,3
set/grap yax=0,{ymax}
plot/row {RAW_IMG}ext1 @{iOtoPlot}
label/graphic "OBJ Fib :: Order {iOtoPlot}" 0.16,0.90,no 0 1 1
assi/grap G,4
set/grap yax=0,{ymax}
plot/row {RAW_IMG}ext2 @{iOtoPlot}
label/graphic "SKY Fib :: Order {iOtoPlot}" 0.16,0.90,no 0 1 1

assi/grap G,0
set/gra default
!@@ ferosInitQC0plot.prg
!set/grap pmode=0 xsc=0.6 ysc=0.7 styp=1 ssize=0.1
set/grap pmode=0 styp=1 ssize=0.1
plot/tabl {CENTER_TBL} :Fit_Pos :Ypos
copy/grap postscript.p
$ mv postscript.ps {OFLABEL}-{p1str}-OrderTrace.ps

SAVE/FEROS {WLC_IMG}
write/out "Session parameters saved as session {WLC_IMG}"

exit:
