! @(#)loadccd.prg	15.1.1.1 (ESO-IPG) 01/12/01 17:34:19
! "@(#) $Id: loadccd.prg,v 1.66 2006/02/02 11:46:25 jpritcha Exp $"
! @@ loadccd.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  loadccd.prg	  
! O.Stahl, A.Kaufer	981105
!
! PURPOSE
! display incoming new frame and start automatic reduction
!
! USAGE
!
! @@ loadccd fileprefix filenumber
!
! with : fileprefix	:  fixed filename prefix set by BIAS
!        filenumber 	:  running 4-digit filenumber
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?     CHAR "Enter fileprefix : "
define/par p2 ?     N    "Enter filenumber : "
define/par p3 MIDASHOME:/calib/data/spec/ctio CHAR "Spectral flux directory"
define/par p4 9999. N    "Focus Offset : "
define/par p5 Null  CHAR "Default Guess-Session for initialisation (ThAr0196) : "
!
define/local i/i/1/1 0
define/local j/i/1/1 0
define/local DoINIT/i/1/1 0
define/local DoRedAll/i/1/1 0

define/local focOff/r/1/1 {p4} ? +lower_levels
define/local TLSstart/r/1/1 0.0
define/local TLSend/r/1/1   0.0
define/local TLSmean/r/1/1  0.0
define/local tra/r/1/1      0.0
define/local tdec/r/1/1     0.0
define/local olat/r/1/1     0.0
define/local LST/r/1/1      0.0
define/local secz/r/1/1     0.0

define/local OBName/c/1/50    " "
define/local OBStart/c/1/20   " " ? +lower_levels
define/local gsess/c/1/80     " " ? +lower_levels
define/local ident/c/1/72     " "
define/local lcident/c/1/72   " "
define/local infile/c/1/40    " " all
define/local symPRF/c/1/1     " "
define/local host/c/1/100     " "
define/local symQCPlots/c/1/1 " "
define/local symMkHTML/c/1/1  " "
define/local symQCURL/c/1/100 " "
define/local DHCoDRSinit/c/1/7     "DRSinit"
define/local TLS/r/1/1        0.
define/local WLCcat/c/1/10    " "
define/local WLCid/c/1/10    " "
DEFINE/LOCAL ARCFILE/C/1/100  " " ? +lower_levels
DEFINE/LOCAL isFIERA/C/1/1    "N"
DEFINE/LOCAL isDRSINIT/C/1/1  "N"
DEFINE/LOCAL DRSInitNumExps/i/1/4  5,10,6,6
DEFINE/LOCAL DRSInitNumTpls/i/1/1  8
define/local xbin/i/1/1       1
define/local ybin/i/1/1       1
define/local FEROSROModeCom/c/1/30    " " ? +lower_levels

DEFINE/LOCAL fBIAS/C/1/11    " "
DEFINE/LOCAL CATAL/I/1/1     0

!! Default Guess Sessions:
!! Guess sessions from 2005-10-01
define/local gNNNN_1x1/c/1/4       "9021"
define/local gThArPref_1x1/c/1/10  "ThAr"
define/local gNNNN_2x2/c/1/4       "9121"
define/local gThArPref_2x2/c/1/10  "ThAr"

write/key infile {p1}{p2}.mt
ARCFILE = "{infile}"
i = m$existd("{infile}","ARCFILE")
if i .eq. 1 ARCFILE = "{{infile},ARCFILE}"
!
! Set guess sessions...
set/format i1
i = m$existd("{infile}","ESO.DET.WIN1.BINX") * m$existd("{infile}","ESO.DET.WIN1.BINY")
if i .eq. 1 then
  xbin = {{infile},ESO.DET.WIN1.BINX}
  ybin = {{infile},ESO.DET.WIN1.BINY}
endif
if "{P5}" .ne. "Null" then
  gsess = "{p5}"
else
  gsess = m$symbol("FEROS_INIT_GUESS")
  if "{gsess}" .eq. "FEROS_INIT_GUESS" gsess = "ThAr0196"
endif
i = m$exist("DEFAULT_INIT_GUESS_{xbin}x{ybin}.tar.gz")
if i .eq. 1 @@ getguess {gNNNN_{xbin}x{ybin}} DEFAULT_INIT_GUESS_{xbin}x{ybin}.tar.gz {gThArPref_{xbin}x{ybin}} Y
write/out "Using guess session {gsess}."
set/format
!
! Work out which fibre was used...
i = m$existk("FEROSObjFib")
if {i} .eq. 0 then
  define/local FEROSObjFib/C/1/1 "1"
  i = m$existd("{infile}","ESO.TEL.AG.FIBSELEC")
  if i .eq. 1 then
    if "{{infile},ESO.TEL.AG.FIBSELEC}" .eq. "SKYFIB" FEROSObjFib = "2"
  endif
endif

!! Multiple Merge Methods...
!! Warning... doesn't (yet) handle SINC AND AVERAGE...
!! Both are written to f{num}, i.e. which ever is done last
!! overwrites what was done previously...
i = m$existk("MultMergMtds")
if i .eq. 0 define/local MultMergMtds/c/1/3 "NS-" ? +lower_levels
!! To do No Merge + SINC
!! write/key MultMergMtds/c/1/3 "NS-"
!! To do No Merge + AVERAGE
!! write/key MultMergMtds/c/1/3 "N-A"
!! To do No Merge + SINC + AVERAGE
!! write/key MultMergMtds/c/1/3 "NSA"
!! ...or other combinations...

! Calculate the focus offset...
i = m$existd("{infile}","focOff")
if i .ne. 1 then
!! Focus equation is:
!! Foc[Theo] = 23740.0 - 66.0 * T[LS] + 2.0 * ZD + FO
!! --> FO = Foc[Theo] - 23740.0 + 66.0 * T[LS] - 2.0 * ZD
!! Foc[Theo] = HIERARCH ESO TEL FOCU VALUE
!! T[LS] = HIERARCH ESO TEL TSS TEMP7 START
!! ZD = 90.0 - HIERARCH ESO TEL ALT
  i = m$existd("{infile}","ESO.TEL.ALT") * m$existd("{infile}","ESO.TEL.FOCU.VALUE")
  i = i * m$existd("{infile}","ESO.TEL.TSS.TEMP7.START") * m$existd("{infile}","ESO.TEL.TSS.TEMP7.END")
  if i .eq. 1 then
    TLS = ( {{infile},ESO.TEL.TSS.TEMP7.START} + {{infile},ESO.TEL.TSS.TEMP7.END}) / 2.0
    focOff =  {{infile},ESO.TEL.FOCU.VALUE} - 23740.0 + 66.0 * TLS - 2.0 * (90. - {{infile},ESO.TEL.ALT} )
    write/out "Computed Focus Offset = {focOff}"
!! Can't write descriptors into FITS files...
!!    write/desc {infile} focOff/r/1/1 {focOff}
  else
    write/out "Warning!!! Do NOT know how to determine Focus Offset."
    focOff = 9999.
  endif
else
  copy/dk {infile} focOff/r/1/1 focOff
endif

write/out "File {infile} received, loading"
crea/dis 0 500,1000,760,0
!stat/ima {infile}

load/ima {infile} sc=-4
! Do the following in the forground otherwise if a 2nd command is
! submitted while the 1st is active (e.g. when reprocessing all
! the calibrations...), ds9 dies!
$ ferosDRSds9LoadImage {infile}
! &
read/desc {infile}
add/icat Feros.cat {infile}

! start automatic reduction
write/out "================================================================================"
write/out "Starting on-line DRS on {infile} "
write/out
!!
!! Since P74, CalPlan Science Exposures such as SolarSpectra and SpecPhot
!! Standards have DPR.CATG set to CALIB, which also sets OBJECT to DPR.TYPE.
!!
ident = m$lower("{{infile},ident}")
i = m$existd("{infile}","ESO.OBS.TARG.NAME")
if i .eq. 1 ident = "{{infile},ESO.OBS.TARG.NAME}"
!!
i = m$existd("{infile}","ESO.DPR.CATG")
if i .eq. 1 then
  write/out "{infile} seems to be a FIERA generated image..."
  isFIERA = "Y"
  i = 0
  if xbin .ne. ybin then
    write/out "loadccd.prg: Binning configuration not implemented. Can not continue."
    goto aorr
  endif
  if xbin .gt. 2 .or. ybin .gt. 2 then
    write/out "loadccd.prg: Binning configuration not implemented. Can not continue."
    goto aorr
  endif
!
!!! Automatically work out if we are doing a standard initialisation...
!!!
!!! *****************************************************************
!!! **  Note this is only intended to be useful at the telescope.  **
!!! **  But actually it works well also with @@ loadccd_cat.       **
!!! *****************************************************************
!!!
!!! The guess session used is specified either by Environment variable
!!! FEROS_INIT_GUESS or by parameter-5. P5 overrides the Env variable.
!!!
!!! Based on the following assumptions:
!!! 1) OB name is of the form <NNN>-StanCal-<ROMode>, e.g. 100-StanCal-norm
!!!    The important thing here is that chars 5:11 = "StanCal"
!!! 2) OB consists of:
!!!      1) Nb x biases
!!!      2) Nf x flats
!!!      3) Nca1 x ThArNe, Nca2 x ThArNe and Nca3 x ThArNe, i.e.
!!!         3 sets of ThArNe WLCs (usually of different expTimes)
!!!      4) Ncb1 x ThAr+Ne, Ncb2 x ThAr+Ne and Ncb3 x ThAr+Ne, i.e.
!!!         3 sets of ThAr+Ne WLCs (usually of different expTimes).
!!!
!!!  Order of 3 & 4 is not important but whichever is last is the
!!!  initialisation that will be used during the night.
!!!
!!!  For the online reduction of BIAS, DARK, FF, ThAr & ThAr+Ne acquired
!!!  after a successfull initialisation it is important that the total number
!!!  of templates be 8 so that RedAllIms/c/1/1="Y" can be set at the end of
!!!  The initialisation.
!!!
!!! Then we reset the DRS when detecting that
!!!   i) ESO.OBS.NAME(5:11) .eq. "StanCal"
!!!  ii) ESO.OBS.TPLNO .eq. 1
!!! iii) ESO.TPL.EXPNO .eq. 1
!!!  iv) ESO.TPL.ID    .eq. "FEROS_ech_cal_bias"
!!! Then we initialise the DRS when detecting that
!!!   i) ESO.OBS.NAME(5:8) .eq. "StanCal"
!!!  ii) ESO.TPL.EXPNO .eq. ESO.TPL.NEXP
!!! iii) ESO.TPL.ID    .eq. "FEROS_ech_cal_wave"
!!!  iv) Number of entries in ThAr.cat = 6
!!! or when
!!!   i) ESO.OBS.NAME(5:8) .eq. "StanCal"
!!!  ii) ESO.TPL.EXPNO .eq. ESO.TPL.NEXP
!!! iii) ESO.TPL.ID    .eq. "FEROS_ech_cal_wave"
!!!  iv) Number of entries in ThArNe.cat = 6
!!!
!!!
!!! 2005-03-11:: Implement autoprocessing of the CALOB calibrations...
!!! Based on the following assumptions:
!!! 1) OB name is "Calibration"
!!!    The important thing here is that chars 1:11 = "Calibration"
!!! 2) An initialisation consists of:
!!!      1) Nb x biases
!!!      2) Nf x flats
!!!      3) Ncb1 x ThAr+Ne, Ncb2 x ThAr+Ne and Ncb3 x ThAr+Ne, i.e.
!!!         3 sets of ThAr+Ne WLCs (usually of different expTimes).
!!!      4) Nca1 x ThArNe, Nca2 x ThArNe and Nca3 x ThArNe, i.e.
!!!         3 sets of ThArNe WLCs (usually of different expTimes), normally
!!!         Nca1=Nca2=Nca3=2. 
!!!
!!! Then we reset the DRS when detecting that
!!!   i) ESO.OBS.NAME(1:11) .eq. "Calibration"
!!!  ii) ESO.OBS.TPLNO .eq. 1
!!! iii) ESO.TPL.EXPNO .eq. 1
!!!  iv) ESO.TPL.ID    .eq. "FEROS_ech_cal_bias"
!!! Then we initialise the DRS when detecting that
!!!   i) ESO.OBS.NAME(1:11) .eq. "Calibration"
!!!  ii) ESO.TPL.EXPNO .eq. ESO.TPL.NEXP
!!! iii) ESO.TPL.ID    .eq. "FEROS_ech_cal_wave"
!!!  iv) Number of entries in ThAr.cat = 6
!!! or when
!!!   i) ESO.OBS.NAME(1:11) .eq. "Calibration"
!!!  ii) ESO.TPL.EXPNO .eq. ESO.TPL.NEXP
!!! iii) ESO.TPL.ID    .eq. "FEROS_ech_cal_wave"
!!!  iv) Number of entries in ThArNe.cat = 6
!!!
!!! 2005-11-19 : Implementation for Daily Health Check Philosophy
!!! =============================================================
!!! Based on the following assumptions:
!!! 1) OB name is of the form <NNN>-FEROS-Daily-Health-Check where <NNN> =
!!!    101 for exaple
!!!    The important thing here is that chars 5:24 = "FEROS-Daily-Health-Check"
!!! ..or...
!!!    OBS.NAME(5:13) = "FEROS-DHC"
!!! 2) OB consists of:
!!!      1) Nb x biases
!!!      2) Nf x flats
!!!      3) Nca1 x ThArNe *or* Nca1 x ThAr+Ne WLCs

  OBName = "{{infile},ESO.OBS.NAME}"
  if "{OBName(5:11)}" .eq. "StanCal" isDRSINIT = "Y"
  if "{OBName(1:11)}" .eq. "Calibration" isDRSINIT = "Y"
  if "{OBName(5:28)}" .eq. "FEROS-Daily-Health-Check" then
    isDRSINIT = "Y"
    write/key DRSInitNumExps/i/1/4 2,2,1,1
    DRSInitNumTpls = 6
  endif
  if "{OBName(5:21)}" .eq. "FEROS-DHC-ThAr+Ne" then
    isDRSINIT = "Y"
    write/key DRSInitNumExps/i/1/4 2,2,1,1
    DRSInitNumTpls = 6
    DHCoDRSinit = "DHC"
  endif
  if "{isDRSINIT}" .eq. "Y" then
    if "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_bias" then
! Daily Health Check provide both 1x1 & 2x2 binning INITs...
!      if {{infile},ESO.OBS.TPLNO} .eq. 1 .and. {{infile},ESO.TPL.EXPNO} .eq. 1 then
      if {{infile},ESO.TPL.EXPNO} .eq. 1 then
        write/key RedAllIms/c/1/1 "N"
        @@ init {gsess} reset
      endif
    endif
  endif
else
  write/out "{infile} seems to be a BIAS generated image..."
!! Need to work out how to check for non 1x1 binning for BIAS...
!  i = 0
!  if {{infile},ESO.DET.WIN1.BINX} .ne. 1 then
!    write/out "loadccd.prg: X-binning = {{infile},ESO.DET.WIN1.BINX} not implemented"
!    i = 1
!  endif
!  if {{infile},ESO.DET.WIN1.BINY} .ne. 1 then
!    write/out "loadccd.prg: Y-binning = {{infile},ESO.DET.WIN1.BINX} not implemented"
!    i = 1
!  endif
!  if i .ne. 0 then
!    write/out "loadccd.prg: Binning configuration not implemented. Can not continue."
!    $ ferosQCWarningOrError E "Red-{ARCFILE(1:29)}" loadccd.prg "Binning configuration not implemented"
!    goto aorr
!  endif
endif
if "{ident(1:6)}" .eq. "qfocus" then
  @@ FEROSCTcomptime {p1}{p2} 1029,2100 ? 3.0E+05
elseif "{ident(1:7)}" .eq. "NDFWenc" then
  @@ FEROSCTcomptime {p1}{p2} 1029,2100
elseif "{ident(1:11)}" .eq. "NDFWdensity" then
  @@ FEROSCTcomptime {p1}{p2} 1029,2100
elseif "{ident(1:9)}" .eq. "FFBalance" then
  @@ FEROSCTcomptime {p1}{p2}  323,2100
  @@ FEROSCTcomptime {p1}{p2} 1029,2100
  @@ FEROSCTcomptime {p1}{p2} 1662,2100
elseif "{ident(1:10)}" .eq. "WLCBalance" then
  write/out "Warning, not yet fully implemented..."
  @@ FEROSCTcomptime {p1}{p2} 1029,2100
  @@ FEROSCTcomptime {p1}{p2} 1665,2135
  @@ FEROSCTcomptime {p1}{p2} 1899,2082
  @@ FEROSCTcomptime {p1}{p2}  122,2128
! the following are Ne lines
  @@ FEROSCTcomptime {p1}{p2}  560,2030
  @@ FEROSCTcomptime {p1}{p2}  873,2088
else
  @@ autoreduce {p1} {p2} {FEROSObjFib}
!
!
!!! Automatically work out if we are doing a standard initialisation... see above...
  DoINIT = 0
  DoRedAll = 0
  if "{isDRSINIT}" .eq. "Y" then
!! Master BIAS
    if "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_bias" .and. {{infile},ESO.TPL.EXPNO} .eq. {{infile},ESO.TPL.NEXP} then
      @@ average_cat Bias.cat N
      catal = 0
      store/frame fBIAS Bias.cat 1
      outdisk/fits Bias{fBIAS(5:8)}.bdf Bias{fBIAS(5:8)}.mt
      $ ferosDRSds9LoadImage -o Bias{fBIAS(5:8)}.ps Bias{fBIAS(5:8)}.mt &
    endif
!
!! Master FLAT
    if "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_flat" .and. {{infile},ESO.TPL.EXPNO} .eq. {{infile},ESO.TPL.NEXP} then
      @@ average_cat FF.cat
      outdisk/fits {RAW_IMG}.bdf {RAW_IMG}.mt
      $ ferosDRSds9LoadImage -o {RAW_IMG}.ps {RAW_IMG}.mt &
    endif
!
! Master WLC
! Do initialisations with BOTH ThArNe and ThAr+Ne calibrations...
    if "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_wave" .and. {{infile},ESO.TPL.EXPNO} .eq. {{infile},ESO.TPL.NEXP} then
      show/icat ThAr.cat N
      if OUTPUTI(1) .eq. DRSInitNumExps(3) then
        DoINIT = 1
        DoRedAll = 1
        WLCcat = "ThAr"
        WLCid  = "ThArNe"
        @@ average_cat {WLCcat}.cat
        outdisk/fits {WLC_IMG}.bdf {WLC_IMG}.mt
        $ ferosDRSds9LoadImage -o {WLC_IMG}.ps {WLC_IMG}.mt &
      endif
    endif
    if "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_ThAr_Ne" .and. {{infile},ESO.TPL.EXPNO} .eq. {{infile},ESO.TPL.NEXP} then
      show/icat ThArNe.cat N
      if OUTPUTI(1) .eq. DRSInitNumExps(4) then
        DoINIT = 1
        DoRedAll = 1
        WLCcat = "ThArNe"
        WLCid  = "ThAr+Ne"
        @@ average_cat {WLCcat}.cat
        outdisk/fits {WLC_IMG}.bdf {WLC_IMG}.mt
        $ ferosDRSds9LoadImage -o {WLC_IMG}.ps {WLC_IMG}.mt &
      endif
    endif
  endif
  if DoINIT .eq. 1 then
! Initialise the DRS...
    copy/dk {infile} O_TIME/d/4/1 MJD
! The FCU halogen filters were changed on the 2004-Sep-09
! thus allowing to reliably SEARCH for the orders instead of having
! to rely on the GUESS.
! Midday Local Time on 2004-Sep-09 == MJD 53257.66667
    if MJD .LT. 53257.66667 then
      @@ init {gsess} flat
    else
      OBStart = "{WLCcat}"
      i = m$existd("{infile}","ESO.OBS.START")
      if i .eq. 1 OBStart = "{{infile},ESO.OBS.START}"
      @@ init {gsess} flat 0.84 ? 0.80,0.90
    endif
    catal = 0
    store/frame fBIAS Bias.cat 1
    @@ ferosMBIASqc0 Bias{fBIAS(5:8)}
    @@ ferosMFLATqc0
    @@ ferosMWLCqc0
! Make html pages...
    symMkHTML = m$symbol("FEROSmkHTML")
    if "{symMkHTML}" .EQ. "Y" then
      $ ferosMkHTML.pl -a mklink -t DRSINIT -F FF.cat -W {WLCcat}.cat -G {gsess} {infile}
    endif
! Make the archives...
    @@ autoMkGandS y y FF.cat {WLCcat}.cat Bias.cat
  endif
  if DoRedAll .eq. 1 then
! Reduce the Flatfield, ThArNe, ThAr+Ne and sol (if they exist) exposures...
    write/key RedAllIms/c/1/1 "Y"
    i = m$exist("Bias.cat")
    if i .eq. 1 @@ autoreduce_cat Bias.cat
    i = m$exist("Dark.cat")
    if i .eq. 1 @@ autoreduce_cat Dark.cat
    @@ autoreduce_cat FF.cat
    @@ autoreduce_cat {WLCcat}.cat
    write/key RedAllIms/c/1/1 "N"
    i = m$exist("sol.cat")
    if i .eq. 1 @@ autoreduce_cat sol.cat
!
! If we are at La Silla...
    host = m$symbol("HOST")
    symQCPlots = m$symbol("FEROSQCPlots")
    if "{host}" .eq. "w2p2off" .OR. "{symQCPlots}" .EQ. "Y" then
      if "{symQCPlots}" .NE. "N" then
        if "{host}" .eq. "w2p2off" $ xterm -iconic -fn 8x16 -display :0.1 -e kstart --desktop 3 --activate "xterm -geometry 1x1-0-0 -e sleep 1"
! S/N in FFs...
        assi/grap G,5
        @@ FFsnr_cat FF.cat ? ? ? Y Y
! Plots...
        assi/grap G,6
        @@ fextRatios_cat FF.cat ? 25,63 1 Y p
        assi/grap G,7
        @@ fextRatios_cat FF.cat ? 25,63 2 Y p
! Plots of template...
        assi/grap G,8
        @@ ferosPlotTemplateT {RAW_IMG} ? Y p
! Focus
        assi/grap G,9
        @@ focus_cat ThAr.cat Y Y
        i = m$exist("ThArNe.cat")
        if i .eq. 1 @@ focus_cat ThArNe.cat Y Y
! Make html pages...
        symMkHTML = m$symbol("FEROSmkHTML")
        if "{symMkHTML}" .EQ. "Y" then
          $ ferosMkHTML.pl -a mklink -t DRSINIT -F FF.cat -W {WLCcat}.cat -G {gsess} {infile}
          $ ferosMkHTML.pl -r -a display -t DRSINIT -F FF.cat -W {WLCcat}.cat -G {gsess} {infile}
          symQCURL = m$symbol("FEROSQCURLroot")
          if "{symQCURL}" .NE. "Y" then
            @@ ferosSetRONandGAIN {infile}
            define/local ThArAF/C/1/50 "{{WLC_IMG},arcfile}"
            $ ferosShowWebPage -P FEROS-QC {symQCURL}/{DHCoDRSinit}/index-{FEROSROModeCom}.html -w {symQCURL(8:)}/{DHCoDRSinit}/WaveSolution/{FEROSROModeCom}/{WLCid}/summary.{ThArAF(7:29)}.dat &
          endif
        endif
! RePlot the initization results....
        assi/grap G,0
        @@ init ? plots
      endif
    endif
  endif
  i = m$existd("{infile}","cident")
  if i .eq. 1 then
    ident = m$lower("{{infile},cident}")
  endif
! Spectrophotometric Standard Stars
  lcident = m$lower("{ident}")
  i = m$exist("{p3}/{lcident}.tbl")
  if i .eq. 1 then
    @@ efficiency {p2} {lcident} {FEROSObjFib} {p3}
    @@ ferosResponse {p2} {lcident} {FEROSObjFib} {p3}
    if "{{infile},ESO.TPL.ID}" .eq. "FEROS_img_cal_focus" then
      @@ ferosProcEffFocSeq {p2} Add {FEROSObjFib}
      if {{infile},ESO.TPL.EXPNO} .eq. {{infile},ESO.TPL.NEXP} then
        @@ ferosProcEffFocSeq {p2} Calc
      endif
    endif
! Make html pages...
    symMkHTML = m$symbol("FEROSmkHTML")
    if "{symMkHTML}" .EQ. "Y" then
      $ ferosMkHTML.pl -a mklink {infile}
    endif
  endif
! Fibre ratio for SolarSpectra...
  if "{ident(1:13)}" .eq. "SolarSpectrum" then
    @@ fiberratio {p2}
! Remake html pages...
    symMkHTML = m$symbol("FEROSmkHTML")
    if "{symMkHTML}" .EQ. "Y" then
      $ ferosMkHTML.pl -a mklink {infile}
    endif
  endif
! S/N
  if "{isFIERA}" .eq. "Y" then
    if "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_objsky" .or. "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_objcal" then
      i = m$exist("f{P2}{FEROSObjFib}.bdf")
      if {i} .EQ. 1 then
        if "{MERGE_MTD(1:1)}" .NE. "N" @@ snrUBVRI {P2} {FEROSObjFib}
      endif
    endif

    if "{isDRSINIT}" .eq. "Y" then
      if {{infile},ESO.OBS.TPLNO} .eq. {DRSInitNumTpls} then
        if {{infile},ESO.TPL.EXPNO} .eq. {{infile},ESO.TPL.NEXP} write/key RedAllIms/c/1/1 "Y"
      endif
    endif
  endif
endif

symPRF = m$symbol("FEROSPackRedFiles")
if "{symPRF}" .EQ. "Y" then
  $ ferosPackRedFiles {p2} &
endif

!$ ferosQCWarningOrError O "Red-{ARCFILE(1:29)}" loadccd.prg "Reduction completed"

!write/out "DARK/C/1/1 = {DARK}"

aorr:
