! "@(#) $Id: makeFFsolArchive.prg,v 1.6 2004/12/04 00:55:50 jpritcha Exp $"
! @@ makeFFsolArchive.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  makeFFsolArchive.prg	  
! P. Francois	990627
! J. Pritchard  20040118
!
! PURPOSE
! Creates a tar archive of the guess FFsolArchive 
! adds the mean ThAr, the mean flat
! and the cross order profile coefficients
! This archive can be directly used with INIT/FEROS	
!
! USAGE
!
! @@ makeFFsolArchive <LLLL> <NNNN> <MMMM>
!
! with : <LLLL>  :  Number of the mean FFsol to be saved
!        <NNNN>  :  Number of the mean ThAr to be saved
!        <MMMM>  :  Number of the mean Flat Field of the session
!
!  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?           N "Enter number of associated mean FFsol : "
define/par p2 ?           N "Enter number of associated mean ThAr : "
define/par p3 ?           N "Enter number of associated mean flat FF  : " 
define/par p4 N           CHAR "Use VLT date-time identifier (y/N) : "

define/local symPRF/c/1/1 " "
define/local id1/c/1/23    "{p1}"
define/local id2/c/1/23    "{p2}"
define/local id3/c/1/23    "{p3}"

if "{p4}" .eq. "y" then
  copy/dk FFsol{p1} ARCFILE/c/7/23 id1
  copy/dk ThAr{p2}  ARCFILE/c/7/23 id2
  copy/dk FF{p3}    ARCFILE/c/7/23 id3
endif

WRITE/OUT 
write/out "            Converting bdf files in FITS files    " 
WRITE/OUT 
outdisk/fits FFsol{p1}.bdf FFsol{p1}.mt
outdisk/fits FFsol{p1}_INIT.tbl  FFsol{p1}_INIT.mt
outdisk/fits FFsol{p1}_GORDER.tbl  FFsol{p1}_GORDER.mt
outdisk/fits FFsol{p1}_LINE1.tbl  FFsol{p1}_LINE1.mt
outdisk/fits FFsol{p1}_LINE2.tbl  FFsol{p1}_LINE2.mt
outdisk/fits FFsol{p1}_ORDER.tbl  FFsol{p1}_ORDER.mt
outdisk/fits FFsol{p1}_TEMPLATE.bdf  FFsol{p1}_TEMPLATE.mt
outdisk/fits FFsol{p1}_WLC1.tbl  FFsol{p1}_WLC1.mt
outdisk/fits FFsol{p1}_WLC2.tbl  FFsol{p1}_WLC2.mt
outdisk/fits ThAr{p2}.bdf ThAr{p2}.mt
outdisk/fits FF{p3}.bdf FF{p3}.mt
outdisk/fits FF{p3}ext1.bdf  FF{p3}ext1.mt
outdisk/fits FF{p3}ext2.bdf  FF{p3}ext2.mt
outdisk/fits cop_coeffs1.tbl cop_coeffs1.mt
outdisk/fits cop_coeffs2.tbl cop_coeffs2.mt
outdisk/fits ThAr50000.tbl ThAr50000.mt
outdisk/fits BLAZE.tbl BLAZE.mt
WRITE/OUT 
WRITE/OUT "         Creating tar file"
WRITE/OUT 
$ tar --force-local -cvf FFsolArchive{id1}_{id2}_{id3}.tar  FFsol{p1}.mt
$ tar --force-local -uvf FFsolArchive{id1}_{id2}_{id3}.tar  FFsol{p1}_*.mt
$ tar --force-local -uvf FFsolArchive{id1}_{id2}_{id3}.tar  ThAr{p2}.mt FF{p3}.mt
$ tar --force-local -uvf FFsolArchive{id1}_{id2}_{id3}.tar  FF{p3}ext1.mt  FF{p3}ext2.mt
$ tar --force-local -uvf FFsolArchive{id1}_{id2}_{id3}.tar  cop_coeffs1.mt cop_coeffs2.mt
$ tar --force-local -uvf FFsolArchive{id1}_{id2}_{id3}.tar  ThAr50000.mt  BLAZE.mt
$ tar --force-local -uvf FFsolArchive{id1}_{id2}_{id3}.tar  FFsol{p1}-*-rms.ps
$ tar --force-local -uvf FFsolArchive{id1}_{id2}_{id3}.tar  FF.cat ThAr.cat FFsol.cat
WRITE/OUT "Compressing the file"
$ gzip -9v FFsolArchive{id1}_{id2}_{id3}.tar
WRITE/OUT
WRITE/OUT " Archive name : FFsolArchive{id1}_{id2}_{id3}.tar.gz "
WRITE/OUT " Archived in $FEROS_DRS/saved_session"
WRITE/OUT
$ cp FFsolArchive{id1}_{id2}_{id3}.tar.gz $FEROS_DRS/saved_session/

symPRF = m$symbol("FEROSPackRedFiles")
if "{symPRF}" .EQ. "Y" then
  $ ferosPackFFsolArchiveTGZ -t FFsolArchive{id1}_{id2}_{id3}.tar.gz {p1} {p2} {p3} &
endif

exit:
