! "@(#) $Id: makeguess.prg,v 1.13 2005/11/26 08:33:41 jpritcha Exp $"
! @@ makeguess.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  makeguess.prg	  
! P. Francois	990614
! J. Pritchard  20040118
!
! PURPOSE
! Creates a tar.gz  archive of the guess session
!
! USAGE
!
! @@ makeguess <NNNN>
!
! with : <NNNN>  :  Number of the mean ThAr to be saved
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! J.D.Pritchard :: 2002-02-23
!    **) Replaced /data1/feros with $HOME
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?           N "Enter number of associated mean ThAr : "
define/par p2 N           CHAR "Use VLT date-time identifier (y/N) : "
define/par p3 N           CHAR "Force gzip (i.e. overwrite already existing tar.gzs (y/N) : "
define/par p4 ThAr        CHAR "ThAr prefix (ThAr) : "

define/local symPRF/c/1/1  " "
define/local id1/c/1/23    "{p1}"
define/local fgz/c/1/7     " "

if "{p2}" .eq. "y" then
  copy/dk {p4}{p1} ARCFILE/c/7/23 id1
endif
if "{p3}" .eq. "y" then
  fgz = "--force"
endif

write/out "converting bdf files in FITS files    " 
outdisk/fits {p4}{p1}_INIT.tbl      {p4}{p1}_INIT.mt
outdisk/fits {p4}{p1}_GORDER.tbl    {p4}{p1}_GORDER.mt
outdisk/fits {p4}{p1}_LINE1.tbl     {p4}{p1}_LINE1.mt
outdisk/fits {p4}{p1}_LINE2.tbl     {p4}{p1}_LINE2.mt
outdisk/fits {p4}{p1}_ORDER.tbl     {p4}{p1}_ORDER.mt
outdisk/fits {p4}{p1}_TEMPLATE.bdf  {p4}{p1}_TEMPLATE.mt
outdisk/fits {p4}{p1}_WLC1.tbl      {p4}{p1}_WLC1.mt
outdisk/fits {p4}{p1}_WLC2.tbl      {p4}{p1}_WLC2.mt
outdisk/fits ThAr50000.tbl ThAr50000.mt
outdisk/fits BLAZE.tbl BLAZE.mt
WRITE/OUT " Creating tar file"
$ tar --force-local -cvf guess{id1}.tar  {p4}{p1}_*.mt ThAr50000.mt BLAZE.mt
WRITE/OUT "Compressing the file"
$ gzip {fgz} -9v guess{id1}.tar
WRITE/OUT " "
WRITE/OUT " Archive name : guess{id1}.tar.gz"
WRITE/OUT " Archived in $FEROS_DRS/saved_session/"
$ cp "guess{id1}.tar.gz" $FEROS_DRS/saved_session/
WRITE/OUT

symPRF = m$symbol("FEROSPackRedFiles")
if "{symPRF}" .EQ. "Y" then
  !! Need this to lookup keyword values...
  outdisk/fits {p4}{p1}.bdf           {p4}{p1}.mt
  $ ferosPackGuessTGZ -W {P4} -t guess{id1}.tar.gz {p1} &
endif

exit:
