! "@(#) $Id: makesession.prg,v 1.16 2006/01/23 16:26:35 jpritcha Exp $"
! @@ makesession.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  makesession.prg	  
! P. Francois	990627
! J. Pritchard  20040118
!
! PURPOSE
! Creates a tar archive of the guess session 
! adds the mean ThAr, the mean flat
! and the cross order profile coefficients
! This archive can be directly used with INIT/FEROS	
!
! USAGE
!
! @@ makesession <NNNN> <MMMM>
!
! with : <NNNN>  :  Number of the mean ThAr to be saved
!        <MMMM>  :  Number of the mean Flat Field of the session
!
!  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?           N "Enter number of associated mean ThAr : "
define/par p2 ?           N "  Enter number of associated mean FF : " 
define/par p3 N           CHAR "Use VLT date-time identifier (y/N) : "
define/par p4 N           CHAR "Force gzip (i.e. overwrite already existing tar.gzs) (y/N) : "
define/par p5 FF          CHAR "FF prefix (FF) : "
define/par p6 ThAr        CHAR "ThAr prefix (ThAr) : "
define/par p7 Null        CHAR "Bias Catalogue : "

define/local symPRF/c/1/1 " "
define/local id1/c/1/23    "{p1}"
define/local id2/c/1/23    "{p2}"
define/local fgz/c/1/7     " "

DEFINE/LOCAL fBIAS/C/1/11    " "
DEFINE/LOCAL CATAL/I/1/1     0
DEFINE/LOCAL i/i/1/1         0
DEFINE/LOCAL l/i/1/1         0

if "{p3}" .eq. "y" then
  copy/dk {p6}{p1} ARCFILE/c/7/23 id1
  copy/dk {p5}{p2} ARCFILE/c/7/23 id2
endif
if "{p4}" .eq. "y" then
  fgz = "--force"
endif

WRITE/OUT " "
write/out "            Converting bdf files in FITS files    " 
WRITE/OUT " "
outdisk/fits {p6}{p1}_INIT.tbl      {p6}{p1}_INIT.mt
outdisk/fits {p6}{p1}_GORDER.tbl    {p6}{p1}_GORDER.mt
outdisk/fits {p6}{p1}_LINE1.tbl     {p6}{p1}_LINE1.mt
outdisk/fits {p6}{p1}_LINE2.tbl     {p6}{p1}_LINE2.mt
outdisk/fits {p6}{p1}_ORDER.tbl     {p6}{p1}_ORDER.mt
outdisk/fits {p6}{p1}_TEMPLATE.bdf  {p6}{p1}_TEMPLATE.mt
outdisk/fits {p6}{p1}_WLC1.tbl      {p6}{p1}_WLC1.mt
outdisk/fits {p6}{p1}_WLC2.tbl      {p6}{p1}_WLC2.mt
outdisk/fits {p6}{p1}.bdf           {p6}{p1}.mt
outdisk/fits {p5}{p2}.bdf           {p5}{p2}.mt
outdisk/fits {p5}{p2}ext1.bdf       {p5}{p2}ext1.mt
outdisk/fits {p5}{p2}ext2.bdf       {p5}{p2}ext2.mt
outdisk/fits cop_coeffs1.tbl        cop_coeffs1.mt
outdisk/fits cop_coeffs2.tbl        cop_coeffs2.mt
outdisk/fits ThAr50000.tbl          ThAr50000.mt
outdisk/fits BLAZE.tbl              BLAZE.mt
if "{P7}" .ne. "Null" then
  catal = 0
  store/frame fBIAS    {p7} 1
  l = m$index("{p7}",".") - 1
  i = m$exist("{p7(1:{l})}{fBIAS(5:8)}.mt")
  if i .ne. 1 outdisk/fits {p7(1:{l})}{fBIAS(5:8)}.bdf {p7(1:{l})}{fBIAS(5:8)}.mt
endif
WRITE/OUT " "
WRITE/OUT "         Creating tar file"
WRITE/OUT " "
$ tar --force-local -cvf session{id1}_{id2}.tar  {p6}{p1}_*.mt
$ tar --force-local -uvf session{id1}_{id2}.tar  {p6}{p1}.mt {p5}{p2}.mt
$ tar --force-local -uvf session{id1}_{id2}.tar  {p5}{p2}ext1.mt  {p5}{p2}ext2.mt
$ tar --force-local -uvf session{id1}_{id2}.tar  cop_coeffs1.mt cop_coeffs2.mt
$ tar --force-local -uvf session{id1}_{id2}.tar  ThAr50000.mt  BLAZE.mt
if "{p3}" .eq. "y" then
  $ tar --force-local -uvf session{id1}_{id2}.tar  FEROS.{id1}-ThAr*-rms*.ps FEROS.{id1}-ThAr*-OrderTrace.ps
else
  $ tar --force-local -uvf session{id1}_{id2}.tar  {p6}{p1}-ThAr*-rms*.ps {p6}{p1}-ThAr*-OrderTrace.ps
endif
$ tar --force-local -uvf session{id1}_{id2}.tar  {p5}.cat {p6}.cat
if "{P7}" .ne. "Null" then
  $ tar --force-local -uvf session{id1}_{id2}.tar {p7} {p7(1:{l})}{fBIAS(5:8)}.mt
endif
WRITE/OUT "Compressing the file"
$ gzip {fgz} -9v session{id1}_{id2}.tar
WRITE/OUT
WRITE/OUT " Archive name : session{id1}_{id2}.tar.gz "
WRITE/OUT " Archived in $FEROS_DRS/saved_session"
WRITE/OUT
$ cp session{id1}_{id2}.tar.gz $FEROS_DRS/saved_session/

symPRF = m$symbol("FEROSPackRedFiles")
if "{symPRF}" .EQ. "Y" then
  $ ferosPackSessionTGZ -t session{id1}_{id2}.tar.gz -F {P5} -W {P6} {p1} {p2} &
endif

exit:
