! "@(#) $Id: optimum.prg,v 1.10 2005/10/17 12:13:27 jpritcha Exp $"
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  optimum.prg	  
! O.Stahl, A.Kaufer, S.Tubbesing	990201
!
! PURPOSE
! reduce  object-frame
!
!				
! 	exposuretype=SCIENCE 	:
!					   order extraction		
!					   flatfielding/blaze correction
!					   rebinning: wavelength calibration
!						      barycentric correction
!					   order merging
!					
! USAGE
!
! @@ optimum filenumber
!
! 
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/local infile/c/1/60 " " all
define/local num/c/1/4 {p1}
define/local i/i/1/1 0
define/local j/i/1/1 0
define/local order/i/1/1 0
define/local ra/d/1/1 0.0
define/local lstart/r/1/1 0.0
define/local lend/r/1/1 0.0
define/local rebstep/r/1/2 0.0
define/local f_mode/c/1/2 OS
define/local etime/D/1/1 0
DEFINE/LOCAL CATAL/I/1/1 0
define/local adisp/r/1/1   0.0
define/local midwl/r/1/1   0.0
define/local xcen/d/1/1    0.0
define/local savemm/c/1/10 " "

i = m$existk("ARCFILE")
if i .ne. 1 then
  DEFINE/LOCAL ARCFILE/C/1/100 " " ? +lower_levels
  i = m$existd("fero{num}.mt","ARCFILE")
  if i .eq. 1 ARCFILE = "{fero{num}.mt,ARCFILE}"
endif
!!
!! Output FITS files in VLT compliant name format, i.e.:
!! r.<ARCFILE>.nnnn.fits
!! To set either:
!! In MIDAS
!!   write/key  UseAFDRSFITS/C/1/1 "Y"
!! or in .bashrc
!!   export FEROSUseAFDRSFITS="Y"
!! or in .cshrc or .tcshrc
!!   setenv FEROSUseAFDRSFITS="Y"
i = m$existk("UseAFDRSFITS")
if i .ne. 1 then
  DEFINE/LOCAL UseAFDRSFITS/C/1/1 " " ? +lower_levels
  UseAFDRSFITS = M$SYMBOL("FEROSUseAFDRSFITS")
endif

!! Multiple Merge Methods...
!! Warning... doesn't (yet) handle SINC AND AVERAGE...
!! Both are written to f{num}, i.e. which ever is done last
!! overwrites what was done previously...
i = m$existk("MultMergMtds")
if i .eq. 0 define/local MultMergMtds/c/1/3 "---"
!! To do No Merge + SINC
!! write/key MultMergMtds/c/1/3 "NS-"
!! To do No Merge + AVERAGE
!! write/key MultMergMtds/c/1/3 "N-A"
!! To do No Merge + SINC + AVERAGE
!! write/key MultMergMtds/c/1/3 "NSA"
!! ...or other combinations...

SET/FERO EXT_MODE=O
EXTRACT/FEROS back_str bo{num}ext {SPECTR_TYPE}{EXT_MODE}{PROFILE_GET}{IMG_WRITE}
FLAT/FERO bo{num}ext {FLAT_IMG} o{num}ext

rebstep(1) = {REBIN_STEP}
rebstep(2) = {raw_image,bary_corr}
i = m$existd("raw_image","f_mode")
if i .eq. 1 then
  write/out "{infile} seems to be a BIAS generated image..."
  f_mode = "{raw_image,f_mode}"
else
  write/out "{infile} seems to be a FIERA generated image..."
  if "{raw_image,ESO.DPR.TYPE}" .eq. "OBJ,CAL"     f_mode = "OC"
  if "{raw_image,ESO.DPR.TYPE}" .eq. "OBJECT,WAVE" f_mode = "OC"
  if "{raw_image,ESO.DPR.TYPE}" .eq. "OBJECT,FLAT" f_mode = "OC"
  if "{raw_image,ESO.DPR.TYPE}" .eq. "STD,WAVE"    f_mode = "OC"
  if "{raw_image,ESO.DPR.TYPE}" .eq. "STD,FLAT"    f_mode = "OC"
! The following are not (yet) implemented in REBIN/FERO
  if "{raw_image,ESO.DPR.TYPE}" .eq. "WAVE,OBJECT" f_mode = "CO"
  if "{raw_image,ESO.DPR.TYPE}" .eq. "FLAT,OBJECT" f_mode = "CO"
  if "{raw_image,ESO.DPR.TYPE}" .eq. "WAVE,STD"    f_mode = "CO"
  if "{raw_image,ESO.DPR.TYPE}" .eq. "FLAT,STD"    f_mode = "CO"
endif

!!! Flat-fielded...
REBIN/FERO o{num}ext {LINE_POS_TBL} rebinned I {rebstep(1)},{rebstep(2)} ? {f_mode}

!!! Non-Flat-fielded...
REBIN/FERO bo{num}ext {LINE_POS_TBL} rebinnedNoFF I {rebstep(1)},{rebstep(2)} ? {f_mode}

!! Multiple Merge Methods...
!! Warning... doesn't (yet) handle SINC AND AVERAGE...
!! Both are written to f{num}, i.e. which ever is done last
!! overwrites what was done previously...
savemm = "{MERGE_MTD}"
i = 0
if MultMergMtds(1:3) .NE. "---" i = 1
MMMloop1:
if i .ne. 0 then
  set/feros MERGE_MTD={MultMergMtds({i}:{i})}
!  write/out "MERGE_MTD = {MERGE_MTD}"
endif
if MERGE_MTD(1:1) .NE. "-" then
  MERGE/FERO rebinnedNoFF noFFo{num} 
  !MERGE/FERO rebinned o{num} {MERGE_DELTA} {MERGE_MTD}
  MERGE/FERO rebinned o{num}
  if i .ne. 0 then
    if i .lt. 3 then
      i = i + 1
      goto MMMloop1
    endif
  endif
endif
write/out
!
! copy all but standard descriptors
!
cop/dd raw_image *,3 bo{num}ext1
cop/dd raw_image *,3 bo{num}ext2
cop/dd raw_image IDENT bo{num}ext1
cop/dd raw_image IDENT bo{num}ext2 
!
cop/dd raw_image *,3 o{num}ext1
cop/dd raw_image *,3 o{num}ext2
cop/dd raw_image IDENT o{num}ext1 
cop/dd raw_image IDENT o{num}ext2 
!
! 
!
if MERGE_MTD(1:1) .EQ. "N" .OR. MultMergMtds(1:1) .EQ. "N" then
  i = 0
  do order = {ORDER_LAST} {ORDER_FIRST} -1
    i = i+1
    cop/dd raw_image *,3 noFFo{num}1{i}
    cop/dd raw_image *,3 noFFo{num}2{i}
    cop/dd raw_image IDENT noFFo{num}1{i} 
    cop/dd raw_image IDENT noFFo{num}2{i}   
    cop/dd raw_image *,3 o{num}1{i}
    cop/dd raw_image *,3 o{num}2{i}
    cop/dd raw_image IDENT o{num}1{i} 
    cop/dd raw_image IDENT o{num}2{i}   
    lstart = {o{num}1{i},START(1)}
    lend   = {o{num}1{i},START(1)}+{o{num}1{i},NPIX(1)}*{o{num}1{i},STEP(1)}
    adisp  = (lend-lstart)/40960
    midwl  = (lstart+(lend-lstart)/4096/2.)/10.
    set/format I4
    i = 40 - i
    copy/dk {WLC_IMG}_ORDER.tbl FIT{i}/d/1/1 xcen/d/1/1
    xcen = (15.36+xcen)/0.015
    i = 40 - i
    set/format F4.0 I4
    write/out "Reduced order {i}/[m={order}], {lstart}-{lend}, saved in o{num}1{i} (object fiber)"
    write/out "                                                 o{num}2{i} (sky fiber)"
    set/format F5.4 I4
    write/out "Average dispersion in order {i}/[{order}] is {adisp} nm / pixel"
    set/format F6.2 I4
    write/out "Wavelength of central row in order {i}/[{order}] is {midwl} nm at x={xcen}"
    write/out " "
    set/format
  enddo
endif
i = 0
if MultMergMtds(2:2) .NE. "-" .OR. MultMergMtds(3:3) .NE. "-" i = 2
if MERGE_MTD(1:1) .NE. "N" .OR. i .ne. 0 then
  MMMloop2:
  if i .ne. 0 then
    set/feros MERGE_MTD={MultMergMtds({i}:{i})}
!    write/out "MERGE_MTD = {MERGE_MTD}"
  endif
  if MERGE_MTD(1:1) .NE. "-" then
    cop/dd raw_image *,3 noFFo{num}1
    cop/dd raw_image *,3 noFFo{num}2
    cop/dd raw_image IDENT noFFo{num}1 
    cop/dd raw_image IDENT noFFo{num}2 
    cop/dd raw_image *,3 o{num}1
    cop/dd raw_image *,3 o{num}2
    cop/dd raw_image IDENT o{num}1 
    cop/dd raw_image IDENT o{num}2 
    lstart = {o{num}1,START(1)}
    lend   = {o{num}1,START(1)}+{o{num}1,NPIX(1)}*{o{num}1,STEP(1)}
    set/format F4.0 I4
    write/out "Reduced 1D spectrum, {lstart}-{lend}, saved in o{num}1 (object fiber)"
    write/out "                                         o{num}2 (sky    fiber)"
    set/format
  endif
  if i .ne. 0 then
    if i .lt. 3 then
      i = i + 1
      goto MMMloop2
    endif
  endif
endif
set/feros MERGE_MTD={savemm}

! Write reduced spectra to fits format
set/format F4.0 I4
if "{ARCFILE(1:1)}" .ne. " " .and. "{UseAFDRSFITS}" .EQ. "Y" then
  outdisk/fits bo{num}ext1.bdf   r.{ARCFILE(1:29)}.2041.fits
  outdisk/fits bo{num}ext2.bdf   r.{ARCFILE(1:29)}.2042.fits
  outdisk/fits o{num}ext1.bdf    r.{ARCFILE(1:29)}.2051.fits
  outdisk/fits o{num}ext2.bdf    r.{ARCFILE(1:29)}.2052.fits
  outdisk/fits rebinned1.bdf     r.{ARCFILE(1:29)}.2061.fits
  outdisk/fits rebinned2.bdf     r.{ARCFILE(1:29)}.2062.fits
  outdisk/fits rebinnedNoFF1.bdf r.{ARCFILE(1:29)}.2063.fits
  outdisk/fits rebinnedNoFF2.bdf r.{ARCFILE(1:29)}.2064.fits
  i = m$exist("o{num}1.bdf")
  if i .eq. 1 then
    outdisk/fits o{num}1.bdf       r.{ARCFILE(1:29)}.2101.fits
    outdisk/fits o{num}2.bdf       r.{ARCFILE(1:29)}.2102.fits
    outdisk/fits noFFo{num}1.bdf   r.{ARCFILE(1:29)}.2103.fits
    outdisk/fits noFFo{num}2.bdf   r.{ARCFILE(1:29)}.2104.fits
  endif
  i = m$exist("o{num}10001.bdf")
  if i .eq. 1 then
    do order = {ORDER_LAST} {ORDER_FIRST} -1
      i = 1 + {ORDER_LAST} - {order}
      j = 2000 + 10 * {order} + 1
      outdisk/fits f{num}1{i}.bdf r.{ARCFILE(1:29)}.{j}.fits
      j = 2000 + 10 * {order} + 2
      outdisk/fits f{num}2{i}.bdf r.{ARCFILE(1:29)}.{j}.fits
      j = 2000 + 10 * {order} + 3
      outdisk/fits noFFf{num}1{i}.bdf r.{ARCFILE(1:29)}.{j}.fits
      j = 2000 + 10 * {order} + 4
      outdisk/fits noFFf{num}2{i}.bdf r.{ARCFILE(1:29)}.{j}.fits
    enddo
  endif
else
  outdisk/fits bo{num}*bdf name=input
  outdisk/fits noFFo{num}*bdf name=input
  outdisk/fits o{num}*bdf name=input
endif
set/format
