! "@(#) $Id: prepare.prg,v 1.16 2006/01/13 15:31:08 jpritcha Exp $"
! @@ prepare.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure prepare.prg   
! O.Stahl, A.Kaufer, S.Tubbesing	990125
!
! PURPOSE
! initialize catalogues for FF, ThAr, Dark and Objects
!
!
!
! USAGE
!
! @@ prepare
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/local tmpname/c/1/40 " " all
define/local infile/c/1/40 " " all
define/local catal/i/1/1 0 
define/local ind/i/1/1 0 
define/local i/i/1/1 0 
define/local ISSCIENCE/i/1/1 0
define/local ISSTD/i/1/1 0
define/local mm/i/1/1 0
DEFINE/LOCAL EXPTYPE/C/1/50 " "
DEFINE/LOCAL TRUEid/C/1/72  " "
!
$ln -s ../Objects.tbl    Objects.tbl
$ln -s ../ThAr50000.tbl  ThAr50000.tbl
$ln -s ../BLAZE.tbl      BLAZE.tbl
$ln -s ../darks/DARK.bdf DARK.bdf

write/out "Resetting catalogues for Flats, ThArs, Biases, and Objects" 
crea/icat ThAr null
crea/icat ThArNe null
crea/icat FF null
crea/icat Bias null
crea/icat Dark null
crea/icat Objects null
crea/icat sol null

! Don't do this otherwise it overrides set/context feroshh
! set/context feros

crea/icat Feros fero????.mt

next:
store/frame infile Feros.cat 1 done

!!
!! Since P74, CalPlan Science Exposures such as SolarSpectra and SpecPhot
!! Standards have DPR.CATG set to CALIB, which also sets OBJECT to DPR.TYPE.
!!
TRUEid = "{{infile},IDENT}"
i = m$existd("{infile}","ESO.OBS.TARG.NAME")
if i .eq. 1 TRUEid = "{{infile},ESO.OBS.TARG.NAME}"

i = m$existd("{infile}","SHSTAT")
if i .eq. 1 THEN
!! Probably a BIAS generated image...
  WRITE/OUT "{infile} seems to be a BIAS generated image..."
  if "{{infile},SHSTAT}" .eq. "CLOSED"  then
    write/descr {infile} EXPTYPE/C/1/12 "DARK        "
    add/icat Dark {infile}
    EXPTYPE = "DARK"
  elseif "{{infile},SHSTAT}" .eq. "OPEN"  then
    i = m$existd("{infile}","ESO.INS.DID")
    if i .eq. 1 then
!! Must be a FEROS-II:Commissioning-VI image...
      if "{{infile},ESO.INS.SCSM.NAME}" .NE. "BOTHFIBS" then 
        add/icat Objects {infile}
        if "{{infile},IDENT}" .eq. "SolarSpectrum" then
          i = m$exist("sol.cat")
          if i .eq. 0 then
            creat/icat sol {infile}
          else
            add/icat sol {infile}
          endif
        endif
        EXPTYPE = "SCIENCE"
      elseif "{{infile},ESO.INS.RSM.NAME}" .eq. "LAMP2" then
        add/icat FF {infile}
        EXPTYPE = "FLATFIELD"
      elseif "{{infile},ESO.INS.RSM.NAME}" .eq. "LAMP1" then
        add/icat ThAr {infile}
        EXPTYPE = "CALIBRATION"
      endif
    else
      if "{{infile},EXPTYPE}" .eq. "CALIBRATION" then
        add/icat ThAr {infile}
      elseif "{{infile},EXPTYPE}" .eq. "FLATFIELD" then
        add/icat FF {infile}
      elseif "{{infile},EXPTYPE}" .eq. "SCIENCE" then 
        add/icat Objects {infile}
        if "{{infile},IDENT}" .eq. "SolarSpectrum" then
          i = m$exist("sol.cat")
          if i .eq. 0 then
            creat/icat sol {infile}
          else
            add/icat sol {infile}
          endif
        endif
      endif
      EXPTYPE = "{{infile},EXPTYPE}"
    endif
  endif
else
!! Probably a FIERA generated image...
  WRITE/OUT "{infile} seems to be a FIERA generated image..."
  ISSCIENCE = 0
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJ,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJ,CAL" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJECT,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJECT,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "OBJECT,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,OBJECT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,OBJECT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,OBJECT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLUX" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,FLUX" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,FLUX" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,VELOC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,VELOC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,VELOC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,TELLURIC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,TELLURIC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,TELLURIC" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,WAVE" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLAT" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,SKY" ISSCIENCE = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,SKY" ISSCIENCE = 1
  ISSTD = 0
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "STD,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,STD" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,STD" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,STD" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLUX,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLUX" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,FLUX" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,FLUX" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "VELOC,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,VELOC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,VELOC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,VELOC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "TELLURIC,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,TELLURIC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,TELLURIC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,TELLURIC" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,WAVE" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "SKY,FLAT" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "WAVE,SKY" ISSTD = 1
  if "{{infile},ESO.DPR.TYPE}" .eq. "FLAT,SKY" ISSTD = 1
  if ISSCIENCE .eq. 1 then
    if "{TRUEid}" .eq. "SolarSpectrum" then
      i = m$exist("sol.cat")
      if i .eq. 0 then
        creat/icat sol.cat {infile} ESO.OBS.TARG.NAME
      else
        add/icat sol.cat {infile}
      endif
      show/icat sol.cat
    else
      if "{{infile},ESO.DPR.CATG}" .eq. "CALIB" ISSTD = 1
      if ISSTD .eq. 1 then
        i = m$exist("std.cat")
        if i .eq. 0 then
          creat/icat std.cat {infile} ESO.OBS.TARG.NAME
        else
          add/icat std.cat {infile}
        endif
        show/icat std.cat
      else
        add/icat Objects {infile}
        show/icat Objects.cat
      endif
    endif
    EXPTYPE = "SCIENCE"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_bias" then
    add/icat Bias.cat {infile}
    show/icat Bias.cat
    EXPTYPE = "BIAS"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_flat" then
    add/icat FF {infile}
    show/icat FF.cat
    EXPTYPE = "Hal+Hal FlatFied"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_wave" then
    add/icat ThAr {infile}
    show/icat ThAr.cat
    EXPTYPE = "ThArNe Wavelength Calibration"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_dark" then
    i = m$exist("Dark.cat")
    if i .eq. 0 then
      creat/icat Dark.cat {infile}
    else
      add/icat Dark.cat {infile}
    endif
    show/icat Dark.cat
    EXPTYPE = "DARK"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_ThAr_Ne" then
    i = m$exist("ThArNe.cat")
    if i .eq. 0 then
      creat/icat ThArNe.cat {infile}
    else
      add/icat ThArNe.cat {infile}
    endif
    show/icat ThArNe.cat
    EXPTYPE = "ThAr+Ne Wavelength Calibration"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_df" then
    i = m$exist("DF.cat")
    if i .eq. 0 then
      creat/icat DF.cat {infile}
    else
      add/icat DF.cat {infile}
    endif
    show/icat DF.cat
    EXPTYPE = "Dome FlatField"
  elseif "{{infile},ESO.TPL.ID}" .eq. "FEROS_ech_cal_D2" then
    i = m$exist("D2Hal.cat")
    if i .eq. 0 then
      creat/icat D2Hal {infile}
      show/icat D2Hal
    else
      add/icat D2Hal {infile}
      show/icat D2Hal
    endif
    EXPTYPE = "D2+Hal FlatField"
  else
    WRITE/OUT "Warning!!! Exposure type NOT recogonised."
    goto done
  endif
  write/descr {infile} EXPTYPE/C/1/12 "{EXPTYPE}                   "
endif

write/out "--------------------------------------------"
write/out "{infile}: Exposure type {EXPTYPE} "
write/out "--------------------------------------------"
!
goto next
done:
