! @(#)prered.prg	15.1.1.1 (ESO-IPG) 01/12/01 17:34:19
! "@(#) $Id: prered.prg,v 1.19 2005/12/15 15:39:31 jpritcha Exp $"
! @@ prered.prg	  
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
! MIDAS procedure  prered.prg	  
! O.Stahl, A.Kaufer,S.Tubbesing	981105
!
! PURPOSE
!  Pre-reduction of FEROS echelle data :
!				convert FITS -> BDF
!				bias subtraction
!				extraction of useful area		
!				bad column correction
!				compute Julian Date, Siderial Time
!				compute Airmass
!
!! WARNING: Adapted to CCD #?? EEV 2kx4k 15mu
!					
! USAGE
!
! @@ prered filenumber outfile
!
! with :  filenumber 	:  running 4-digit filenumber
!	  outfile	:  optional name of outfile, 
!			   if not given, oufile will be b{filenumber}
!
! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!
define/par p1 ?   N "Enter 4 digit filenumber:"
define/par p2 TMP ? "Output filename:"
define/par p3 Y   CHAR "Subtract BIAS (Y/n) : "
!
define/local infile/i/1/1   {p1}
define/local tmpfile/c/1/20 {p2}
define/local bias/r/1/1     0
define/local bthresh/r/1/3  -1.,-1.,-1.
define/local ra/d/1/1       0.0
define/local start/d/1/2    0.000,0.000

define/local step/d/1/2     0.015,0.015
define/local size/i/1/2     2148,4102
define/local i/i/1/2        0
define/local isaBIAS/i/1/1  0
define/local isFIERA/i/1/1  0
define/local MJD/d/1/1      0.0
define/local cfocOff/r/1/1  0.
define/local xbin/i/1/1     1
define/local ybin/i/1/1     1
define/local osStart/i/1/2  3,2
define/local osEnd/i/1/2    47,23
define/local SciRegStart/i/1/2  51,26
define/local SciRegEnd/i/1/2    2096,1049

define/local romode/c/1/30 " "

i = m$existd("fero{infile}.mt","ESO.DET.WIN1.BINX") * m$existd("fero{infile}.mt","ESO.DET.WIN1.BINY")
if i .eq. 1 then
  xbin = {fero{infile}.mt,ESO.DET.WIN1.BINX}
  ybin = {fero{infile}.mt,ESO.DET.WIN1.BINY}
  step(1) = step(1) * xbin
  size(1) = size(1) / xbin
  step(2) = step(2) * ybin
  size(2) = size(2) / ybin
  if {xbin} .ne. 1 then
    write/out "prered.prg: X-binning = {fero{infile}.mt,ESO.DET.WIN1.BINX} support experimental"
  endif
  if {ybin} .ne. 1 then
    write/out "prered.prg: Y-binning = {fero{infile}.mt,ESO.DET.WIN1.BINX} support experimental"
  endif
  if xbin .ne. ybin then
    write/out "prered.prg: Binning configuration not implemented. Can not continue."
    goto aorr
  endif
  if xbin .gt. 2 .or. ybin .gt. 2 then
    write/out "prered.prg: Binning configuration not implemented. Can not continue."
    goto aorr
  endif
else
    write/out "prered.prg: Don't know how to determine Binning configuration."
    write/out "prered.prg: Trying to continue anyway..."
endif

! convert FITS -> BDF
!
indisk/fits fero{infile}.mt fero{infile}

!!! The focus Offset, i.e. the difference between the 
!!! actual focus at the time of the start of the exposure and the focus
!!! predicted by the theoretical focus equation...
!
!!! if the focOff keyword exists, use that value.
i = m$existk("focOff")
if i .eq. 1 then
  write/desc fero{infile} focOff/r/1/1 {focOff}
else
!!! Try to calculate the focus offset...
!! First check if all the required descriptors are present...
!
! Zenith Distance at start of exposure...
  i = m$existd("fero{infile}","ESO.TEL.")
!
! T Long Surrurier at start of exposure...
  i = i * m$existd("fero{infile}","ESO.TEL.")
!
! Actual focus setting at start of exposure...
  i = i * m$existd("fero{infile}","ESO.TEL.")
!
!! If all three descriptors exist we can calculate the focus offset...
  if i .eq. 1 then
!!    cfocOff = Actual focus 24000 + ... * TLS + ... * ZD
!!    write/desc fero{infile} focOff/r/1/1 {cfocOff}
  endif
endif
!
! check for right detector name
!
i = m$existd("fero{infile}","DETNAME")
i(2) = m$existd("fero{infile}","ESO.DET.CHIP1.NAME")
if i .eq. 1 then
  if "{fero{infile},DETNAME}" .ne. "EEV 2k x 4k" then
    write/out "WARNING: Detector Name has changed !"
    write/out "         verify software settings in prered.prg first !!!"
    return
  endif
elseif i(2) .eq. 1 then
  if "{fero{infile},ESO.DET.CHIP1.NAME}" .ne. "EEV CCD-44" then
    write/out "WARNING: Detector Name has changed !"
    write/out "         verify software settings in prered.prg first !!!"
    return
  endif
endif

! compute bias from overscan region
!
i = m$existd("fero{infile}.mt","SHSTAT")
if i .eq. 1 then
  write/out "fero{infile} seems to be a BIAS generated image..."
  i = m$existd("fero{infile}.mt","CCDCCFG")
  if {i} .eq. 1 then
    if "{fero{infile},CCDCCFG}" .EQ. "1111111111" THEN
      if "{fero{infile},GAINM}" .EQ. "LOW" THEN
        BTHRESH(1) = 200.
      else if "{fero{infile},GAINM}" .EQ. "HIGH" THEN
        BTHRESH(1) = 400.
      endif
    endif
    if "{fero{infile},CCDCCFG}" .EQ. "2222222222" THEN
      if "{fero{infile},GAINM}" .EQ. "LOW" THEN
        BTHRESH(1) = 375.
      else if "{fero{infile},GAINM}" .EQ. "HIGH" THEN
        BTHRESH(1) = 419.
      endif
    endif
  endif
  if BTHRESH(1) .LT. 0. THEN
    write/out "prered.prg:: Don't know how to estimate BIAS level..."
    if "{fero{infile},GAINM}" .EQ. "LOW" THEN
      BTHRESH(1) = 375.
! 2002-Oct-01 == MJD 52549.0
      copy/dk fero{infile} o_time/d/4/1 mjd
      if mjd .lt. 52549.0 BTHRESH(1) = 205.
      write/out "Assuming BIAS = ~{BTHRESH(1)}"
    else if "{fero{infile},GAINM}" .EQ. "HIGH" THEN
      BTHRESH(1) = 420.
      write/out "Assuming BIAS = ~{BTHRESH(1)}"
    endif
  endif
else
  write/out "fero{infile} seems to be a FIERA generated image..."
  isFIERA = 1
  romode = "{fero{infile},ESO.DET.READ.CLOCK}"
  if "{romode(1:16)}" .eq. "R 60Kps High Gai" then
    BTHRESH(1) = 379.
  elseif "{romode(1:16)}" .eq. "R 225Kps Low Gai" then
    BTHRESH(1) = 229.
  elseif "{romode(1:16)}" .eq. "R 625Kps Med Gai" then
    BTHRESH(1) = 269.
  else
    write/out "WARNING!!! Readout mode not recognised, BIAS level unknown..."
    BTHRESH(1) = 100.
  endif
endif

BTHRESH(2) = BTHRESH(1) - 50.
BTHRESH(3) = BTHRESH(1) + 50.

stat/ima fero{infile} [@{osStart({xbin})},<:@{osEnd({xbin})},>] #101 {BTHRESH(2)},{BTHRESH(3)}
!plot/histo fero{infile} 
bias = outputr(8)
write/out "bias level from OverScan = {bias}"

! extract useful area 
!
IF {isFIERA} .EQ. 1 THEN
! Between 2003-Nov-01 and 2004-Apr-23T16:30 with the chip format was:
!    columns
!  =============
!   -49 -- -2   prescan   (48 columns)
!    -1 -- 2046 SCIENCE   (2048 columns)
!  2047 -- 2098 postscan  (52 columns)
!    rows
!  =============
!     1 -- 4096 SCIENCE   (4096 columns)
! This problem was fixed on 2004-Apr-23T16:30, since that time until
! 2005-Apr-16T16:30 the chip format was:
!    columns
!  =============
!   -49 -- 0    prescan   (50 columns)
!     1 -- 2048 SCIENCE   (2048 columns)
!  2049 -- 2098 postscan  (50 columns)
!    rows
!  =============
!     1 -- 4096 SCIENCE   (4096 columns)
! On 2005-Apr-16 the CCD readout This problem was fixed on 2004-Apr-23T16:30, since that time until
! 2005-Apr-16T21:21:00 the chip format was:
!    columns
!  =============
!     1 -- 50   prescan   (50 columns)
!    51 -- 2098 SCIENCE   (2048 columns)
!  2019 -- 2148 postscan  (50 columns)
!    rows
!  =============
!     1 -- 4096 SCIENCE   (4096 columns)
!
! Therefore three case are required to account for these three situations:
! 2004-Apr-23T16:30 == MJD 53118.68750000
! 2005-Apr-16T16:30 == MJD 53476.68750000
!
! There are 6 less rows in FIERA images...???
  size(2) = 4096 / ybin
!
! In MIDAS MJD is stored into position 4 of the O_TIME descriptor...
  copy/dk fero{infile}.mt O_TIME/d/4/1 MJD
  if MJD .LT. 53118.68750000 then
    write/key SciRegStart/i/1/2   49,24
    write/key SciRegEnd/i/1/2   2096,1048
    write/out "Extracting region [@49,<:@2096,>]"
    extr/ima b{infile} = fero{infile}[@49,<:@2096,>]
! set world coordinates to mm, chip center=0mm,0mm
    start(1) = ({b{infile},start(1)}+51.-size(1)/2.)*step(1)
  elseif MJD .LT. 53476.68750000 then
    write/out "Extracting region [@51,<:@2096,>]"
    extr/ima b{infile} = fero{infile}[@51,<:@2098,>]
! set world coordinates to mm, chip center=0mm,0mm
    start(1) = ({b{infile},start(1)}+49.-size(1)/2.)*step(1)
  else
    write/out "Post CCD change..."
    write/out "Extracting region [@{SciRegStart({xbin})},<:@{SciRegEnd({xbin})},>]"
    extr/ima b{infile} = fero{infile}[@{SciRegStart({xbin})},<:@{SciRegEnd({xbin})},>]
! set world coordinates to mm, chip center=0mm,0mm
    start(1) = ({b{infile},start(1)}-1-size(1)/2.)*step(1)
  endif
!
ELSE
! For BIAS images the CCD format was:
!    columns
!  =============
!   -49 -- 0    prescan   (50 columns)
!     1 -- 2048 SCIENCE   (2048 columns)
!  2049 -- 2098 postscan  (50 columns)
!    rows
!  =============
!     1 -- 4102 SCIENCE   (4102 columns)
  extr/ima b{infile} = fero{infile}[@51,<:@2098,>]
!
! set world coordinates to mm, chip center=0mm,0mm
  start(1) = ({b{infile},start(1)}-1.-size(1)/2.)*step(1)
ENDIF
! set world coordinates to mm, chip center=0mm,0mm
start(2) = ({b{infile},start(2)}-1.-size(2)/2.)*step(2)
write/desc b{infile} start/d/1/2 {start(1)},{start(2)}
write/desc b{infile} step/d/1/2  {step(1)},{step(2)}
dele/ima fero{infile} NO

! replace bad columns by mean of neighboring columns
!
!@@ colmean b{infile}  336,344,647,901,1063,1065,1300,1702
!Halpha !
if xbin .eq. 1 then
  @@ colmean b{infile}  321,327,336,344,647,901,1063,1065,1300,1702
elseif xbin .eq. 2 then
  @@ colmean b{infile}  112,161,164,168,324,532,650
  @@ colmean b{infile}  649
!  @@ colmean b{infile}  650
endif

! subtract bias 
!
isaBIAS = 0
i = m$existd("fero{infile}.mt",ESO.TPL.ID)
if i .eq. 1 then
  if "{fero{infile}.mt,ESO.TPL.ID}" .eq. "FEROS_ech_cal_bias" isaBias = 1
endif
if "{P3}" .ne. "n" .and. isaBIAS .eq. 0 comp/ima b{infile} = b{infile}-{bias}

read/descr  b{infile}

!!! convert ra in degree's, only necessary for early COMM1 data!!!
!!!
! ra = {b{infile},o_pos(1)}
! comp/key ra = ra/15.
! write/desc b{infile} o_pos/d/1/1 {ra}
!!!
!!!

! compute Julian Date
! 
compute/st b{infile}

! compute Airmass
!
compute/air b{infile}

! rename frame 
!
if "{tmpfile}" .ne. "TMP" then
  rename/ima b{infile} {p2}
  write/out "Pre-reduced frame renamed to {p2}"
else
  write/out "Pre-reduced frame is named b{infile}"
endif

aorr:
